#pragma once
// Copyright (c) 2001-2021 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <system/iequatable.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace Generation
{
enum class BarcodeClassifications;
class SymbologyEncodeType;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace Generation {

class ASPOSE_BARCODE_SHARED_CLASS BaseEncodeType : public System::IEquatable<System::SharedPtr<Aspose::BarCode::Generation::BaseEncodeType>>
{
    typedef BaseEncodeType ThisType;
    typedef System::IEquatable<System::SharedPtr<Aspose::BarCode::Generation::BaseEncodeType>> BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::SymbologyEncodeType;
    
public:

    ASPOSE_BARCODE_SHARED_API int16_t get_TypeIndex() const;
    ASPOSE_BARCODE_SHARED_API System::String get_TypeName() const;
    ASPOSE_BARCODE_SHARED_API BarcodeClassifications get_Classification() const;
    
    ASPOSE_BARCODE_SHARED_API System::String GetString();
    static ASPOSE_BARCODE_SHARED_API System::String GetString(System::SharedPtr<BaseEncodeType> instance);
    static ASPOSE_BARCODE_SHARED_API bool TryParse(System::String parsingType, System::SharedPtr<BaseEncodeType>& result);
    static ASPOSE_BARCODE_SHARED_API bool TryParse(System::String parsingType, System::SharedPtr<SymbologyEncodeType>& result);
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<BaseEncodeType> Parse(System::String stringEncodeType);
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<BaseEncodeType> other) override;
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    BaseEncodeType(int16_t typeIndex, System::String typeName, BarcodeClassifications classification);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(BaseEncodeType, CODEPORTING_ARGS(int16_t typeIndex, System::String typeName, BarcodeClassifications classification));
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    int16_t _typeIndex;
    System::String _typeName;
    BarcodeClassifications _classification;
    
    BaseEncodeType();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(BaseEncodeType, CODEPORTING_ARGS());
    System::String ToString_NonConst();
    
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose


