#pragma once
// Copyright (c) 2001-2024 Aspose Pty Ltd. All Rights Reserved.

#include <system/array.h>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace Generation
{
class BaseEncodeType;
class CoreImageParameters;
class CoreImageRenderer;
class RendererFactory;
class SymbologyEncodeType;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace Generation {

class ASPOSE_BARCODE_SHARED_CLASS EncodeTypes
{
    typedef EncodeTypes ThisType;
    
    friend class Aspose::BarCode::Generation::CoreImageParameters;
    friend class Aspose::BarCode::Generation::CoreImageRenderer;
    friend class Aspose::BarCode::Generation::RendererFactory;
    
public:

    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> None;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> Codabar;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> Code11;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> Code39;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> Code39FullASCII;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> Code93;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> Code128;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> GS1Code128;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> EAN8;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> EAN13;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> EAN14;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> SCC14;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> SSCC18;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> UPCA;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> UPCE;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> ISBN;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> ISSN;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> ISMN;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> Standard2of5;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> Interleaved2of5;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> Matrix2of5;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> ItalianPost25;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> IATA2of5;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> ITF14;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> ITF6;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> MSI;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> VIN;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> DeutschePostIdentcode;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> DeutschePostLeitcode;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> OPC;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> PZN;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> Code16K;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> Pharmacode;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> DataMatrix;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> QR;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> Aztec;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> GS1Aztec;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> Pdf417;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> MacroPdf417;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> GS1DataMatrix;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> MicroPdf417;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> GS1MicroPdf417;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> GS1QR;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> MaxiCode;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> DotCode;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> HanXin;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> GS1HanXin;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> MicroQR;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> RectMicroQR;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> AustraliaPost;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> Postnet;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> Planet;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> OneCode;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> RM4SCC;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> Mailmark;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> DatabarOmniDirectional;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> DatabarTruncated;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> DatabarLimited;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> DatabarExpanded;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> DatabarExpandedStacked;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> DatabarStacked;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> DatabarStackedOmniDirectional;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> SingaporePost;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> AustralianPosteParcel;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> SwissPostParcel;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> PatchCode;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> Code32;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> DataLogic2of5;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> DutchKIX;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> UpcaGs1Code128Coupon;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> UpcaGs1DatabarCoupon;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> CodablockF;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> GS1CodablockF;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> GS1CompositeBar;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> HIBCCode39LIC;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> HIBCCode128LIC;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> HIBCAztecLIC;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> HIBCDataMatrixLIC;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> HIBCQRLIC;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> HIBCCode39PAS;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> HIBCCode128PAS;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> HIBCAztecPAS;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> HIBCDataMatrixPAS;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> HIBCQRPAS;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SymbologyEncodeType> GS1DotCode;
    
    static ASPOSE_BARCODE_SHARED_API System::ArrayPtr<System::SharedPtr<BaseEncodeType>> get_AllEncodeTypes();
    
    static ASPOSE_BARCODE_SHARED_API System::ArrayPtr<System::String> GetNames();
    static ASPOSE_BARCODE_SHARED_API bool Parse(System::String parsingType, System::SharedPtr<BaseEncodeType>& result);
    static ASPOSE_BARCODE_SHARED_API bool TryParse(System::String parsingType, System::SharedPtr<BaseEncodeType>& result);
    
protected:

    static bool Is2D(System::SharedPtr<BaseEncodeType> symbology);
    static bool IsMaxiCode(System::SharedPtr<BaseEncodeType> symbology);
    static bool IsDotCode(System::SharedPtr<BaseEncodeType> symbology);
    static bool IsAztec(System::SharedPtr<BaseEncodeType> symbology);
    static bool IsQr(System::SharedPtr<BaseEncodeType> symbology);
    static bool IsDatamatrix(System::SharedPtr<BaseEncodeType> symbology);
    static bool IsMicroPdf417(System::SharedPtr<BaseEncodeType> symbology);
    static bool IsPdf417(System::SharedPtr<BaseEncodeType> symbology);
    static bool IsHanXin(System::SharedPtr<BaseEncodeType> symbology);
    static bool IsPatchCode(System::SharedPtr<BaseEncodeType> symbology);
    static bool Is1D(System::SharedPtr<BaseEncodeType> symbology);
    
private:

    static System::ArrayPtr<System::SharedPtr<BaseEncodeType>> _allSupportedTypes;
    
    static struct __StaticConstructor__ { __StaticConstructor__(); } s_constructor__;
    
public:
    EncodeTypes() = delete;
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose


