#pragma once
// Copyright (c) 2001-2025 Aspose Pty Ltd. All Rights Reserved.

#include <system/date_time.h>
#include <system/array.h>
#include <drawing/color.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace ComplexBarcode
{
class ComplexBarcodeGenerator;
} // namespace ComplexBarcode
enum class CustomerInformationInterpretingType;
namespace Generation
{
class AustralianPostParameters;
enum class AztecEncodeMode;
class AztecParameters;
enum class AztecSymbolMode;
class BarcodeGenerator;
class BarcodeWithGuardsRenderer;
class BaseEncodeType;
class BaseGenerationParameters;
class BaseRenderer;
class CMYKColor;
enum class CodabarChecksumMode;
class CodabarParameters;
enum class CodabarSymbol : int16_t;
class CodablockParameters;
enum class Code128EncodeMode;
class Code128Parameters;
class Code16KParameters;
class CodetextParameters;
class ComplexBarcode;
class CoreImageParameters;
class CouponParameters;
class DataBarParameters;
enum class DataMatrixEccType;
enum class DataMatrixEncodeMode;
class DataMatrixParameters;
enum class DataMatrixVersion;
enum class DotCodeEncodeMode;
class DotCodeParameters;
class DotCodeRenderer;
enum class ECIEncodings;
enum class EnableChecksum;
class GS1CompositeBarParameters;
enum class HanXinEncodeMode;
enum class HanXinErrorLevel;
class HanXinParameters;
enum class HanXinVersion;
enum class ITF14BorderType;
class ITFParameters;
enum class MacroCharacter;
enum class MaxiCodeEncodeMode;
enum class MaxiCodeMode;
class MaxiCodeParameters;
enum class MicroQRVersion;
class Padding;
namespace ParamsSpecification
{
class AustralianPosteParcelParamsSpecification;
class AustraliaPostParamsSpecification;
class Code128ParamsSpecification;
class Code32ParamsSpecification;
class DatabarParamsSpecification;
class DeutschePostIdentcodeParamsSpecification;
class DeutschePostLeitcodeParamsSpecification;
class DotCodeParamsSpecification;
class EAN13ParamsSpecification;
class EAN14ParamsSpecification;
class EAN8ParamsSpecification;
class GS1AztecParamsSpecification;
class GS1CodablockFParamsSpecification;
class GS1Code128ParamsSpecification;
class GS1CompositeBarParamsSpecification;
class GS1DotCodeParamsSpecification;
class GS1For2DParamsSpecification;
class GS1HanXinParamsSpecification;
class GS1MicroPdf417ParamsSpecification;
class HanXinParamsSpecification;
class HIBCLICFor1DParamsSpecification;
class HIBCLICFor2DParamsSpecification;
class HIBCPASFor1DParamsSpecification;
class HIBCPASFor2DParamsSpecification;
class Interleaved2of5ParamsSpecification;
class ISBNParamsSpecification;
class ISMNParamsSpecification;
class ISSNParamsSpecification;
class ITF14ParamsSpecification;
class ITF6ParamsSpecification;
class MailmarkParamsSpecification;
class MaxiCodeParamsSpecification;
class OneCodeParamsSpecification;
class OPCParamsSpecification;
class ParamsSpecificationFactory;
class PatchCodeParamsSpecification;
class PharmacodeParamsSpecification;
class PZNParamsSpecification;
class RM4SCCParamsSpecification;
class SCC14ParamsSpecification;
class SingaporePostParamsSpecification;
class SSCC18ParamsSpecification;
class SwissPostParcelParamsSpecification;
class TwoDParamsSpecification;
class UpcaGs1Code128CouponParamsSpecification;
class UPCAParamsSpecification;
class UPCEParamsSpecification;
class VINParamsSpecification;
} // namespace ParamsSpecification
class PatchCodePageRenderer;
class PatchCodeParameters;
enum class PatchFormat;
enum class Pdf417CompactionMode;
enum class Pdf417EncodeMode;
enum class Pdf417ErrorLevel;
enum class Pdf417MacroTerminator;
class Pdf417Parameters;
class PostalParameters;
enum class QREncodeMode;
enum class QREncodeType;
enum class QRErrorLevel;
class QrParameters;
class QrStructuredAppendParameters;
enum class QRVersion;
enum class RectMicroQRVersion;
class RendererFactory;
class Simple2DRenderer;
class SimpleBarcodeRenderer;
class SimpleBarcodeWithSupplementRenderer;
class SupplementParameters;
enum class TwoDComponentType;
class Unit;
} // namespace Generation
namespace Serialization
{
namespace Xml
{
class BarcodeParametersParser;
class CouponParametersParser;
class SupplementParametersParser;
} // namespace Xml
} // namespace Serialization
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace Generation {

class ASPOSE_BARCODE_SHARED_CLASS BarcodeParameters : public System::Object
{
    typedef BarcodeParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeGenerator;
    friend class Aspose::BarCode::Generation::ParamsSpecification::AustralianPosteParcelParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Code128ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::AustraliaPostParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::TwoDParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Code32ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DatabarParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1For2DParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DeutschePostIdentcodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Interleaved2of5ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DeutschePostLeitcodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DotCodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::EAN13ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::EAN14ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1Code128ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::EAN8ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1AztecParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1CodablockFParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1CompositeBarParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1DotCodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1HanXinParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::HanXinParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1MicroPdf417ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::HIBCLICFor1DParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::HIBCLICFor2DParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::HIBCPASFor1DParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::HIBCPASFor2DParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ISBNParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ISMNParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ISSNParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ITF14ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ITF6ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::MailmarkParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::RM4SCCParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::MaxiCodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::OneCodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::OPCParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ParamsSpecificationFactory;
    friend class Aspose::BarCode::Generation::ParamsSpecification::PatchCodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::PharmacodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::PZNParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::SCC14ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::SSCC18ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::SingaporePostParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::SwissPostParcelParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::UpcaGs1Code128CouponParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::UPCAParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::UPCEParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::VINParamsSpecification;
    friend class Aspose::BarCode::Generation::BaseGenerationParameters;
    friend class Aspose::BarCode::Generation::CoreImageParameters;
    friend class Aspose::BarCode::Generation::BarcodeWithGuardsRenderer;
    friend class Aspose::BarCode::Generation::SimpleBarcodeWithSupplementRenderer;
    friend class Aspose::BarCode::Generation::SimpleBarcodeRenderer;
    friend class Aspose::BarCode::Generation::DotCodeRenderer;
    friend class Aspose::BarCode::Generation::PatchCodePageRenderer;
    friend class Aspose::BarCode::Generation::Simple2DRenderer;
    friend class Aspose::BarCode::Generation::BaseRenderer;
    friend class Aspose::BarCode::Generation::RendererFactory;
    friend class Aspose::BarCode::Serialization::Xml::BarcodeParametersParser;
    friend class Aspose::BarCode::ComplexBarcode::ComplexBarcodeGenerator;
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Unit> get_XDimension() const;
    ASPOSE_BARCODE_SHARED_API void set_XDimension(System::SharedPtr<Unit> value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Unit> get_BarHeight() const;
    ASPOSE_BARCODE_SHARED_API void set_BarHeight(System::SharedPtr<Unit> value);
    ASPOSE_BARCODE_SHARED_API System::Drawing::Color get_BarColor() const;
    ASPOSE_BARCODE_SHARED_API void set_BarColor(System::Drawing::Color value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Aspose::BarCode::Generation::Padding> get_Padding() const;
    ASPOSE_BARCODE_SHARED_API bool get_ChecksumAlwaysShow() const;
    ASPOSE_BARCODE_SHARED_API void set_ChecksumAlwaysShow(bool value);
    ASPOSE_BARCODE_SHARED_API EnableChecksum get_IsChecksumEnabled() const;
    ASPOSE_BARCODE_SHARED_API void set_IsChecksumEnabled(EnableChecksum value);
    ASPOSE_BARCODE_SHARED_API bool get_EnableEscape() const;
    ASPOSE_BARCODE_SHARED_API void set_EnableEscape(bool value);
    ASPOSE_BARCODE_SHARED_API bool get_ThrowExceptionWhenCodeTextIncorrect() const;
    ASPOSE_BARCODE_SHARED_API void set_ThrowExceptionWhenCodeTextIncorrect(bool value);
    ASPOSE_BARCODE_SHARED_API float get_WideNarrowRatio() const;
    ASPOSE_BARCODE_SHARED_API void set_WideNarrowRatio(float value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<CodetextParameters> get_CodeTextParameters() const;
    ASPOSE_BARCODE_SHARED_API bool get_FilledBars() const;
    ASPOSE_BARCODE_SHARED_API void set_FilledBars(bool value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Unit> get_BarWidthReduction() const;
    ASPOSE_BARCODE_SHARED_API void set_BarWidthReduction(System::SharedPtr<Unit> value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<PostalParameters> get_Postal() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<PatchCodeParameters> get_PatchCode() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<AustralianPostParameters> get_AustralianPost() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<DataBarParameters> get_DataBar() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<GS1CompositeBarParameters> get_GS1CompositeBar() const;
    ASPOSE_BARCODE_SHARED_API void set_GS1CompositeBar(System::SharedPtr<GS1CompositeBarParameters> value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<CodablockParameters> get_Codablock() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<DataMatrixParameters> get_DataMatrix() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Code16KParameters> get_Code16K() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<DotCodeParameters> get_DotCode() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<ITFParameters> get_ITF() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Pdf417Parameters> get_Pdf417() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<QrParameters> get_QR() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<SupplementParameters> get_Supplement() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<MaxiCodeParameters> get_MaxiCode() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<AztecParameters> get_Aztec() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Code128Parameters> get_Code128() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<CodabarParameters> get_Codabar() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<CouponParameters> get_Coupon() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<HanXinParameters> get_HanXin() const;
    
protected:

    System::SharedPtr<BaseEncodeType> get_BarcodeType() const;
    void set_BarcodeType(System::SharedPtr<BaseEncodeType> value);
    System::String get_CodeText() const;
    void set_CodeText(System::String value);
    System::SharedPtr<CMYKColor> get_CMYKBarColor() const;
    void set_CMYKBarColor(System::SharedPtr<CMYKColor> value);
    ASPOSE_BARCODE_SHARED_API void set_Padding(System::SharedPtr<Aspose::BarCode::Generation::Padding> value);
    ASPOSE_BARCODE_SHARED_API void set_CodeTextParameters(System::SharedPtr<CodetextParameters> value);
    System::SharedPtr<Aspose::BarCode::Generation::ComplexBarcode> get_ComplexBarcode() const;
    System::ArrayPtr<int32_t> get_RowHeights() const;
    void set_RowHeights(System::ArrayPtr<int32_t> value);
    System::Drawing::Color get_BackColor() const;
    void set_BackColor(System::Drawing::Color value);
    System::SharedPtr<CMYKColor> get_CMYKBackColor() const;
    void set_CMYKBackColor(System::SharedPtr<CMYKColor> value);
    float get_Resolution() const;
    void set_Resolution(float value);
    
    BarcodeParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(BarcodeParameters, CODEPORTING_ARGS());
    int32_t GetSupplementSpace();
    int32_t GetPostalShortBarHeight();
    float GetAspectRatio();
    int32_t GetColumns();
    void SetColumns(int32_t columns);
    int32_t GetRows();
    void SetRows(int32_t rows);
    int32_t GetQuietZonesWidthInXDim();
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<BaseEncodeType> pr_BarcodeType;
    System::String pr_CodeText;
    System::SharedPtr<Unit> pr_XDimension;
    System::SharedPtr<Unit> pr_BarHeight;
    System::Drawing::Color pr_BarColor;
    System::SharedPtr<CMYKColor> pr_CMYKBarColor;
    System::SharedPtr<Aspose::BarCode::Generation::Padding> pr_Padding;
    bool pr_ChecksumAlwaysShow;
    EnableChecksum pr_IsChecksumEnabled;
    bool pr_EnableEscape;
    bool pr_ThrowExceptionWhenCodeTextIncorrect;
    System::SharedPtr<CodetextParameters> pr_CodeTextParameters;
    bool pr_FilledBars;
    System::SharedPtr<Unit> pr_BarWidthReduction;
    System::SharedPtr<PostalParameters> pr_Postal;
    
    ASPOSE_BARCODE_SHARED_API void set_Postal(System::SharedPtr<PostalParameters> value);
    
    System::SharedPtr<PatchCodeParameters> pr_PatchCode;
    
    ASPOSE_BARCODE_SHARED_API void set_PatchCode(System::SharedPtr<PatchCodeParameters> value);
    
    System::SharedPtr<AustralianPostParameters> pr_AustralianPost;
    
    ASPOSE_BARCODE_SHARED_API void set_AustralianPost(System::SharedPtr<AustralianPostParameters> value);
    
    System::SharedPtr<DataBarParameters> pr_DataBar;
    
    ASPOSE_BARCODE_SHARED_API void set_DataBar(System::SharedPtr<DataBarParameters> value);
    
    System::SharedPtr<GS1CompositeBarParameters> pr_GS1CompositeBar;
    System::SharedPtr<CodablockParameters> pr_Codablock;
    
    ASPOSE_BARCODE_SHARED_API void set_Codablock(System::SharedPtr<CodablockParameters> value);
    
    System::SharedPtr<DataMatrixParameters> pr_DataMatrix;
    
    ASPOSE_BARCODE_SHARED_API void set_DataMatrix(System::SharedPtr<DataMatrixParameters> value);
    
    System::SharedPtr<Code16KParameters> pr_Code16K;
    
    ASPOSE_BARCODE_SHARED_API void set_Code16K(System::SharedPtr<Code16KParameters> value);
    
    System::SharedPtr<DotCodeParameters> pr_DotCode;
    
    ASPOSE_BARCODE_SHARED_API void set_DotCode(System::SharedPtr<DotCodeParameters> value);
    
    System::SharedPtr<ITFParameters> pr_ITF;
    
    ASPOSE_BARCODE_SHARED_API void set_ITF(System::SharedPtr<ITFParameters> value);
    
    System::SharedPtr<Pdf417Parameters> pr_Pdf417;
    
    ASPOSE_BARCODE_SHARED_API void set_Pdf417(System::SharedPtr<Pdf417Parameters> value);
    
    System::SharedPtr<QrParameters> pr_QR;
    
    ASPOSE_BARCODE_SHARED_API void set_QR(System::SharedPtr<QrParameters> value);
    
    System::SharedPtr<SupplementParameters> pr_Supplement;
    
    ASPOSE_BARCODE_SHARED_API void set_Supplement(System::SharedPtr<SupplementParameters> value);
    
    System::SharedPtr<MaxiCodeParameters> pr_MaxiCode;
    
    ASPOSE_BARCODE_SHARED_API void set_MaxiCode(System::SharedPtr<MaxiCodeParameters> value);
    
    System::SharedPtr<AztecParameters> pr_Aztec;
    
    ASPOSE_BARCODE_SHARED_API void set_Aztec(System::SharedPtr<AztecParameters> value);
    
    System::SharedPtr<Code128Parameters> pr_Code128;
    
    ASPOSE_BARCODE_SHARED_API void set_Code128(System::SharedPtr<Code128Parameters> value);
    
    System::SharedPtr<CodabarParameters> pr_Codabar;
    
    ASPOSE_BARCODE_SHARED_API void set_Codabar(System::SharedPtr<CodabarParameters> value);
    
    System::SharedPtr<CouponParameters> pr_Coupon;
    
    ASPOSE_BARCODE_SHARED_API void set_Coupon(System::SharedPtr<CouponParameters> value);
    
    System::SharedPtr<HanXinParameters> pr_HanXin;
    
    ASPOSE_BARCODE_SHARED_API void set_HanXin(System::SharedPtr<HanXinParameters> value);
    
    System::SharedPtr<Aspose::BarCode::Generation::ComplexBarcode> pr_ComplexBarcode;
    
    void set_ComplexBarcode(System::SharedPtr<Aspose::BarCode::Generation::ComplexBarcode> value);
    
    float _wideNarrowRatio;
    System::ArrayPtr<int32_t> pr_RowHeights;
    System::Drawing::Color pr_BackColor;
    System::SharedPtr<CMYKColor> pr_CMYKBackColor;
    float pr_Resolution;
    
};

class ComplexBarcode : public System::Object
{
    typedef ComplexBarcode ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    RTTI_INFO_DECL();
    
public:

    bool get_DrawSwissCross() const;
    void set_DrawSwissCross(bool value);
    
    ComplexBarcode();
    
private:

    bool pr_DrawSwissCross;
    
};

class ASPOSE_BARCODE_SHARED_CLASS CouponParameters : public System::Object
{
    typedef CouponParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeGenerator;
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    friend class Aspose::BarCode::Generation::ParamsSpecification::UpcaGs1Code128CouponParamsSpecification;
    friend class Aspose::BarCode::Generation::BaseGenerationParameters;
    friend class Aspose::BarCode::Serialization::Xml::CouponParametersParser;
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Unit> get_SupplementSpace() const;
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    ASPOSE_BARCODE_SHARED_API void set_SupplementSpace(System::SharedPtr<Unit> value);
    
    CouponParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(CouponParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<Unit> _space;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS Code128Parameters : public System::Object
{
    typedef Code128Parameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::Code128EncodeMode get_Code128EncodeMode() const;
    ASPOSE_BARCODE_SHARED_API void set_Code128EncodeMode(Aspose::BarCode::Generation::Code128EncodeMode value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    Code128Parameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Code128Parameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    Aspose::BarCode::Generation::Code128EncodeMode pr_Code128EncodeMode;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS CodabarParameters : public System::Object
{
    typedef CodabarParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::CodabarChecksumMode get_CodabarChecksumMode() const;
    ASPOSE_BARCODE_SHARED_API void set_CodabarChecksumMode(Aspose::BarCode::Generation::CodabarChecksumMode value);
    ASPOSE_BARCODE_SHARED_API CodabarSymbol get_CodabarStartSymbol() const;
    ASPOSE_BARCODE_SHARED_API void set_CodabarStartSymbol(CodabarSymbol value);
    ASPOSE_BARCODE_SHARED_API CodabarSymbol get_CodabarStopSymbol() const;
    ASPOSE_BARCODE_SHARED_API void set_CodabarStopSymbol(CodabarSymbol value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    CodabarParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(CodabarParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    Aspose::BarCode::Generation::CodabarChecksumMode pr_CodabarChecksumMode;
    CodabarSymbol pr_CodabarStartSymbol;
    CodabarSymbol pr_CodabarStopSymbol;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS AztecParameters : public System::Object
{
    typedef AztecParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::AztecEncodeMode get_AztecEncodeMode() const;
    ASPOSE_BARCODE_SHARED_API void set_AztecEncodeMode(Aspose::BarCode::Generation::AztecEncodeMode value);
    ASPOSE_BARCODE_SHARED_API ECIEncodings get_ECIEncoding() const;
    ASPOSE_BARCODE_SHARED_API void set_ECIEncoding(ECIEncodings value);
    ASPOSE_BARCODE_SHARED_API int32_t get_StructuredAppendBarcodeId() const;
    ASPOSE_BARCODE_SHARED_API void set_StructuredAppendBarcodeId(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_StructuredAppendBarcodesCount() const;
    ASPOSE_BARCODE_SHARED_API void set_StructuredAppendBarcodesCount(int32_t value);
    ASPOSE_BARCODE_SHARED_API System::String get_StructuredAppendFileId() const;
    ASPOSE_BARCODE_SHARED_API void set_StructuredAppendFileId(System::String value);
    ASPOSE_BARCODE_SHARED_API int32_t get_AztecErrorLevel() const;
    ASPOSE_BARCODE_SHARED_API void set_AztecErrorLevel(int32_t value);
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::AztecSymbolMode get_AztecSymbolMode() const;
    ASPOSE_BARCODE_SHARED_API void set_AztecSymbolMode(Aspose::BarCode::Generation::AztecSymbolMode value);
    ASPOSE_BARCODE_SHARED_API int32_t get_LayersCount() const;
    ASPOSE_BARCODE_SHARED_API void set_LayersCount(int32_t value);
    ASPOSE_BARCODE_SHARED_API bool get_IsReaderInitialization() const;
    ASPOSE_BARCODE_SHARED_API void set_IsReaderInitialization(bool value);
    ASPOSE_BARCODE_SHARED_API float get_AspectRatio() const;
    ASPOSE_BARCODE_SHARED_API void set_AspectRatio(float value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    AztecParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(AztecParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    int32_t _aztectErrorLevel;
    float _aspectRatio;
    Aspose::BarCode::Generation::AztecEncodeMode pr_AztecEncodeMode;
    ECIEncodings pr_ECIEncoding;
    int32_t pr_StructuredAppendBarcodeId;
    int32_t pr_StructuredAppendBarcodesCount;
    System::String pr_StructuredAppendFileId;
    Aspose::BarCode::Generation::AztecSymbolMode pr_AztecSymbolMode;
    int32_t pr_LayersCount;
    bool pr_IsReaderInitialization;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS MaxiCodeParameters : public System::Object
{
    typedef MaxiCodeParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::MaxiCodeMode get_MaxiCodeMode() const;
    ASPOSE_BARCODE_SHARED_API void set_MaxiCodeMode(Aspose::BarCode::Generation::MaxiCodeMode value);
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::MaxiCodeEncodeMode get_MaxiCodeEncodeMode() const;
    ASPOSE_BARCODE_SHARED_API void set_MaxiCodeEncodeMode(Aspose::BarCode::Generation::MaxiCodeEncodeMode value);
    ASPOSE_BARCODE_SHARED_API ECIEncodings get_ECIEncoding() const;
    ASPOSE_BARCODE_SHARED_API void set_ECIEncoding(ECIEncodings value);
    ASPOSE_BARCODE_SHARED_API int32_t get_MaxiCodeStructuredAppendModeBarcodeId() const;
    ASPOSE_BARCODE_SHARED_API void set_MaxiCodeStructuredAppendModeBarcodeId(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_MaxiCodeStructuredAppendModeBarcodesCount() const;
    ASPOSE_BARCODE_SHARED_API void set_MaxiCodeStructuredAppendModeBarcodesCount(int32_t value);
    ASPOSE_BARCODE_SHARED_API float get_AspectRatio() const;
    ASPOSE_BARCODE_SHARED_API void set_AspectRatio(float value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    MaxiCodeParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(MaxiCodeParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    float _aspectRatio;
    Aspose::BarCode::Generation::MaxiCodeMode pr_MaxiCodeMode;
    Aspose::BarCode::Generation::MaxiCodeEncodeMode pr_MaxiCodeEncodeMode;
    ECIEncodings pr_ECIEncoding;
    int32_t pr_MaxiCodeStructuredAppendModeBarcodeId;
    int32_t pr_MaxiCodeStructuredAppendModeBarcodesCount;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS SupplementParameters : public System::Object
{
    typedef SupplementParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeGenerator;
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    friend class Aspose::BarCode::Generation::BaseGenerationParameters;
    friend class Aspose::BarCode::Serialization::Xml::SupplementParametersParser;
    
public:

    ASPOSE_BARCODE_SHARED_API System::String get_SupplementData() const;
    ASPOSE_BARCODE_SHARED_API void set_SupplementData(System::String value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Unit> get_SupplementSpace() const;
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    ASPOSE_BARCODE_SHARED_API void set_SupplementSpace(System::SharedPtr<Unit> value);
    
    SupplementParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(SupplementParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::String pr_SupplementData;
    System::SharedPtr<Unit> _space;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS QrParameters : public System::Object
{
    typedef QrParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API ECIEncodings get_QrECIEncoding() const;
    ASPOSE_BARCODE_SHARED_API void set_QrECIEncoding(ECIEncodings value);
    ASPOSE_BARCODE_SHARED_API QREncodeMode get_QrEncodeMode() const;
    ASPOSE_BARCODE_SHARED_API void set_QrEncodeMode(QREncodeMode value);
    ASPOSE_BARCODE_SHARED_API QREncodeType get_QrEncodeType() const;
    ASPOSE_BARCODE_SHARED_API void set_QrEncodeType(QREncodeType value);
    ASPOSE_BARCODE_SHARED_API QRErrorLevel get_QrErrorLevel() const;
    ASPOSE_BARCODE_SHARED_API void set_QrErrorLevel(QRErrorLevel value);
    ASPOSE_BARCODE_SHARED_API QRVersion get_QrVersion() const;
    ASPOSE_BARCODE_SHARED_API void set_QrVersion(QRVersion value);
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::MicroQRVersion get_MicroQRVersion() const;
    ASPOSE_BARCODE_SHARED_API void set_MicroQRVersion(Aspose::BarCode::Generation::MicroQRVersion value);
    ASPOSE_BARCODE_SHARED_API RectMicroQRVersion get_RectMicroQrVersion() const;
    ASPOSE_BARCODE_SHARED_API void set_RectMicroQrVersion(RectMicroQRVersion value);
    ASPOSE_BARCODE_SHARED_API float get_AspectRatio() const;
    ASPOSE_BARCODE_SHARED_API void set_AspectRatio(float value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<QrStructuredAppendParameters> get_StructuredAppend() const;
    ASPOSE_BARCODE_SHARED_API void set_StructuredAppend(System::SharedPtr<QrStructuredAppendParameters> value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    QrParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(QrParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    ECIEncodings pr_QrECIEncoding;
    float _aspectRatio;
    QREncodeMode pr_QrEncodeMode;
    QREncodeType pr_QrEncodeType;
    QRErrorLevel pr_QrErrorLevel;
    QRVersion pr_QrVersion;
    Aspose::BarCode::Generation::MicroQRVersion pr_MicroQRVersion;
    RectMicroQRVersion pr_RectMicroQrVersion;
    System::SharedPtr<QrStructuredAppendParameters> pr_StructuredAppend;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS QrStructuredAppendParameters : public System::Object
{
    typedef QrStructuredAppendParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::QrParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API uint8_t get_ParityByte() const;
    ASPOSE_BARCODE_SHARED_API void set_ParityByte(uint8_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_SequenceIndicator() const;
    ASPOSE_BARCODE_SHARED_API void set_SequenceIndicator(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_TotalCount() const;
    ASPOSE_BARCODE_SHARED_API void set_TotalCount(int32_t value);
    
protected:

    QrStructuredAppendParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(QrStructuredAppendParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    
private:

    uint8_t pr_ParityByte;
    int32_t _sequenceIndicator;
    int32_t _totalCount;
    
};

class ASPOSE_BARCODE_SHARED_CLASS HanXinParameters : public System::Object
{
    typedef HanXinParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::HanXinVersion get_HanXinVersion() const;
    ASPOSE_BARCODE_SHARED_API void set_HanXinVersion(Aspose::BarCode::Generation::HanXinVersion value);
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::HanXinErrorLevel get_HanXinErrorLevel() const;
    ASPOSE_BARCODE_SHARED_API void set_HanXinErrorLevel(Aspose::BarCode::Generation::HanXinErrorLevel value);
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::HanXinEncodeMode get_HanXinEncodeMode() const;
    ASPOSE_BARCODE_SHARED_API void set_HanXinEncodeMode(Aspose::BarCode::Generation::HanXinEncodeMode value);
    ASPOSE_BARCODE_SHARED_API ECIEncodings get_HanXinECIEncoding() const;
    ASPOSE_BARCODE_SHARED_API void set_HanXinECIEncoding(ECIEncodings value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    HanXinParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(HanXinParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    Aspose::BarCode::Generation::HanXinVersion pr_HanXinVersion;
    Aspose::BarCode::Generation::HanXinErrorLevel pr_HanXinErrorLevel;
    Aspose::BarCode::Generation::HanXinEncodeMode pr_HanXinEncodeMode;
    ECIEncodings pr_HanXinECIEncoding;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS Pdf417Parameters : public System::Object
{
    typedef Pdf417Parameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::Pdf417CompactionMode get_Pdf417CompactionMode() const;
    ASPOSE_BARCODE_SHARED_API void set_Pdf417CompactionMode(Aspose::BarCode::Generation::Pdf417CompactionMode value);
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::Pdf417EncodeMode get_Pdf417EncodeMode() const;
    ASPOSE_BARCODE_SHARED_API void set_Pdf417EncodeMode(Aspose::BarCode::Generation::Pdf417EncodeMode value);
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::Pdf417ErrorLevel get_Pdf417ErrorLevel() const;
    ASPOSE_BARCODE_SHARED_API void set_Pdf417ErrorLevel(Aspose::BarCode::Generation::Pdf417ErrorLevel value);
    ASPOSE_BARCODE_SHARED_API bool get_Pdf417Truncate() const;
    ASPOSE_BARCODE_SHARED_API void set_Pdf417Truncate(bool value);
    ASPOSE_BARCODE_SHARED_API int32_t get_Columns() const;
    ASPOSE_BARCODE_SHARED_API void set_Columns(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_Rows() const;
    ASPOSE_BARCODE_SHARED_API void set_Rows(int32_t value);
    ASPOSE_BARCODE_SHARED_API float get_AspectRatio() const;
    ASPOSE_BARCODE_SHARED_API void set_AspectRatio(float value);
    ASPOSE_BARCODE_SHARED_API int32_t get_Pdf417MacroFileID() const;
    ASPOSE_BARCODE_SHARED_API void set_Pdf417MacroFileID(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_Pdf417MacroSegmentID() const;
    ASPOSE_BARCODE_SHARED_API void set_Pdf417MacroSegmentID(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_Pdf417MacroSegmentsCount() const;
    ASPOSE_BARCODE_SHARED_API void set_Pdf417MacroSegmentsCount(int32_t value);
    ASPOSE_BARCODE_SHARED_API System::String get_Pdf417MacroFileName() const;
    ASPOSE_BARCODE_SHARED_API void set_Pdf417MacroFileName(System::String value);
    ASPOSE_BARCODE_SHARED_API System::DateTime get_Pdf417MacroTimeStamp() const;
    ASPOSE_BARCODE_SHARED_API void set_Pdf417MacroTimeStamp(System::DateTime value);
    ASPOSE_BARCODE_SHARED_API System::String get_Pdf417MacroSender() const;
    ASPOSE_BARCODE_SHARED_API void set_Pdf417MacroSender(System::String value);
    ASPOSE_BARCODE_SHARED_API System::String get_Pdf417MacroAddressee() const;
    ASPOSE_BARCODE_SHARED_API void set_Pdf417MacroAddressee(System::String value);
    ASPOSE_BARCODE_SHARED_API int32_t get_Pdf417MacroFileSize() const;
    ASPOSE_BARCODE_SHARED_API void set_Pdf417MacroFileSize(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_Pdf417MacroChecksum() const;
    ASPOSE_BARCODE_SHARED_API void set_Pdf417MacroChecksum(int32_t value);
    ASPOSE_BARCODE_SHARED_API ECIEncodings get_Pdf417ECIEncoding() const;
    ASPOSE_BARCODE_SHARED_API void set_Pdf417ECIEncoding(ECIEncodings value);
    ASPOSE_BARCODE_SHARED_API ECIEncodings get_Pdf417MacroECIEncoding() const;
    ASPOSE_BARCODE_SHARED_API void set_Pdf417MacroECIEncoding(ECIEncodings value);
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::Pdf417MacroTerminator get_Pdf417MacroTerminator() const;
    ASPOSE_BARCODE_SHARED_API void set_Pdf417MacroTerminator(Aspose::BarCode::Generation::Pdf417MacroTerminator value);
    ASPOSE_BARCODE_SHARED_API bool get_IsReaderInitialization() const;
    ASPOSE_BARCODE_SHARED_API void set_IsReaderInitialization(bool value);
    ASPOSE_BARCODE_SHARED_API MacroCharacter get_MacroCharacters() const;
    ASPOSE_BARCODE_SHARED_API void set_MacroCharacters(MacroCharacter value);
    ASPOSE_BARCODE_SHARED_API bool get_IsLinked() const;
    ASPOSE_BARCODE_SHARED_API void set_IsLinked(bool value);
    ASPOSE_BARCODE_SHARED_API bool get_IsCode128Emulation() const;
    ASPOSE_BARCODE_SHARED_API void set_IsCode128Emulation(bool value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    Pdf417Parameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Pdf417Parameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    float _aspectRatio;
    Aspose::BarCode::Generation::Pdf417CompactionMode pr_Pdf417CompactionMode;
    Aspose::BarCode::Generation::Pdf417EncodeMode pr_Pdf417EncodeMode;
    Aspose::BarCode::Generation::Pdf417ErrorLevel pr_Pdf417ErrorLevel;
    bool pr_Pdf417Truncate;
    int32_t pr_Columns;
    int32_t pr_Rows;
    int32_t pr_Pdf417MacroFileID;
    int32_t pr_Pdf417MacroSegmentID;
    int32_t pr_Pdf417MacroSegmentsCount;
    System::String pr_Pdf417MacroFileName;
    System::DateTime pr_Pdf417MacroTimeStamp;
    System::String pr_Pdf417MacroSender;
    System::String pr_Pdf417MacroAddressee;
    int32_t pr_Pdf417MacroFileSize;
    int32_t pr_Pdf417MacroChecksum;
    ECIEncodings pr_Pdf417ECIEncoding;
    ECIEncodings pr_Pdf417MacroECIEncoding;
    Aspose::BarCode::Generation::Pdf417MacroTerminator pr_Pdf417MacroTerminator;
    bool pr_IsReaderInitialization;
    MacroCharacter pr_MacroCharacters;
    bool pr_IsLinked;
    bool pr_IsCode128Emulation;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS ITFParameters : public System::Object
{
    typedef ITFParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Unit> get_ItfBorderThickness() const;
    ASPOSE_BARCODE_SHARED_API void set_ItfBorderThickness(System::SharedPtr<Unit> value);
    ASPOSE_BARCODE_SHARED_API ITF14BorderType get_ItfBorderType() const;
    ASPOSE_BARCODE_SHARED_API void set_ItfBorderType(ITF14BorderType value);
    ASPOSE_BARCODE_SHARED_API int32_t get_QuietZoneCoef() const;
    ASPOSE_BARCODE_SHARED_API void set_QuietZoneCoef(int32_t value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    ITFParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(ITFParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    int32_t _quietZoneCoef;
    System::SharedPtr<Unit> pr_ItfBorderThickness;
    ITF14BorderType pr_ItfBorderType;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS DotCodeParameters : public System::Object
{
    typedef DotCodeParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API float get_AspectRatio() const;
    ASPOSE_BARCODE_SHARED_API void set_AspectRatio(float value);
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::DotCodeEncodeMode get_DotCodeEncodeMode() const;
    ASPOSE_BARCODE_SHARED_API void set_DotCodeEncodeMode(Aspose::BarCode::Generation::DotCodeEncodeMode value);
    ASPOSE_BARCODE_SHARED_API bool get_IsReaderInitialization() const;
    ASPOSE_BARCODE_SHARED_API void set_IsReaderInitialization(bool value);
    ASPOSE_BARCODE_SHARED_API int32_t get_DotCodeStructuredAppendModeBarcodeId() const;
    ASPOSE_BARCODE_SHARED_API void set_DotCodeStructuredAppendModeBarcodeId(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_DotCodeStructuredAppendModeBarcodesCount() const;
    ASPOSE_BARCODE_SHARED_API void set_DotCodeStructuredAppendModeBarcodesCount(int32_t value);
    ASPOSE_BARCODE_SHARED_API ECIEncodings get_ECIEncoding() const;
    ASPOSE_BARCODE_SHARED_API void set_ECIEncoding(ECIEncodings value);
    ASPOSE_BARCODE_SHARED_API int32_t get_Rows() const;
    ASPOSE_BARCODE_SHARED_API void set_Rows(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_Columns() const;
    ASPOSE_BARCODE_SHARED_API void set_Columns(int32_t value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    DotCodeParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(DotCodeParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    float _aspectRatio;
    Aspose::BarCode::Generation::DotCodeEncodeMode pr_DotCodeEncodeMode;
    bool pr_IsReaderInitialization;
    int32_t pr_DotCodeStructuredAppendModeBarcodeId;
    int32_t pr_DotCodeStructuredAppendModeBarcodesCount;
    ECIEncodings pr_ECIEncoding;
    int32_t _rows;
    int32_t _colums;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS Code16KParameters : public System::Object
{
    typedef Code16KParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API float get_AspectRatio() const;
    ASPOSE_BARCODE_SHARED_API void set_AspectRatio(float value);
    ASPOSE_BARCODE_SHARED_API int32_t get_QuietZoneLeftCoef() const;
    ASPOSE_BARCODE_SHARED_API void set_QuietZoneLeftCoef(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_QuietZoneRightCoef() const;
    ASPOSE_BARCODE_SHARED_API void set_QuietZoneRightCoef(int32_t value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    Code16KParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Code16KParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    
private:

    int32_t _quietZoneLeftCoef;
    int32_t _quietZoneRightCoef;
    float _aspectRatio;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS DataMatrixParameters : public System::Object
{
    typedef DataMatrixParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API DataMatrixEccType get_DataMatrixEcc() const;
    ASPOSE_BARCODE_SHARED_API void set_DataMatrixEcc(DataMatrixEccType value);
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::DataMatrixVersion get_DataMatrixVersion() const;
    ASPOSE_BARCODE_SHARED_API void set_DataMatrixVersion(Aspose::BarCode::Generation::DataMatrixVersion value);
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::DataMatrixEncodeMode get_DataMatrixEncodeMode() const;
    ASPOSE_BARCODE_SHARED_API void set_DataMatrixEncodeMode(Aspose::BarCode::Generation::DataMatrixEncodeMode value);
    ASPOSE_BARCODE_SHARED_API int32_t get_StructuredAppendBarcodeId() const;
    ASPOSE_BARCODE_SHARED_API void set_StructuredAppendBarcodeId(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_StructuredAppendBarcodesCount() const;
    ASPOSE_BARCODE_SHARED_API void set_StructuredAppendBarcodesCount(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_StructuredAppendFileId() const;
    ASPOSE_BARCODE_SHARED_API void set_StructuredAppendFileId(int32_t value);
    ASPOSE_BARCODE_SHARED_API bool get_IsReaderProgramming() const;
    ASPOSE_BARCODE_SHARED_API void set_IsReaderProgramming(bool value);
    ASPOSE_BARCODE_SHARED_API MacroCharacter get_MacroCharacters() const;
    ASPOSE_BARCODE_SHARED_API void set_MacroCharacters(MacroCharacter value);
    ASPOSE_BARCODE_SHARED_API int32_t get_Columns() const;
    ASPOSE_BARCODE_SHARED_API void set_Columns(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_Rows() const;
    ASPOSE_BARCODE_SHARED_API void set_Rows(int32_t value);
    ASPOSE_BARCODE_SHARED_API float get_AspectRatio() const;
    ASPOSE_BARCODE_SHARED_API void set_AspectRatio(float value);
    ASPOSE_BARCODE_SHARED_API ECIEncodings get_ECIEncoding() const;
    ASPOSE_BARCODE_SHARED_API void set_ECIEncoding(ECIEncodings value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    DataMatrixParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(DataMatrixParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    float _aspectRatio;
    DataMatrixEccType pr_DataMatrixEcc;
    Aspose::BarCode::Generation::DataMatrixVersion pr_DataMatrixVersion;
    Aspose::BarCode::Generation::DataMatrixEncodeMode pr_DataMatrixEncodeMode;
    int32_t pr_StructuredAppendBarcodeId;
    int32_t pr_StructuredAppendBarcodesCount;
    int32_t pr_StructuredAppendFileId;
    bool pr_IsReaderProgramming;
    MacroCharacter pr_MacroCharacters;
    int32_t pr_Columns;
    int32_t pr_Rows;
    ECIEncodings pr_ECIEncoding;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS CodablockParameters : public System::Object
{
    typedef CodablockParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API int32_t get_Columns() const;
    ASPOSE_BARCODE_SHARED_API void set_Columns(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_Rows() const;
    ASPOSE_BARCODE_SHARED_API void set_Rows(int32_t value);
    ASPOSE_BARCODE_SHARED_API float get_AspectRatio() const;
    ASPOSE_BARCODE_SHARED_API void set_AspectRatio(float value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    CodablockParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(CodablockParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    
private:

    float _aspectRatio;
    int32_t pr_Columns;
    int32_t pr_Rows;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS DataBarParameters : public System::Object
{
    typedef DataBarParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API bool get_Is2DCompositeComponent() const;
    ASPOSE_BARCODE_SHARED_API void set_Is2DCompositeComponent(bool value);
    ASPOSE_BARCODE_SHARED_API bool get_IsAllowOnlyGS1Encoding() const;
    ASPOSE_BARCODE_SHARED_API void set_IsAllowOnlyGS1Encoding(bool value);
    ASPOSE_BARCODE_SHARED_API int32_t get_Columns() const;
    ASPOSE_BARCODE_SHARED_API void set_Columns(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_Rows() const;
    ASPOSE_BARCODE_SHARED_API void set_Rows(int32_t value);
    ASPOSE_BARCODE_SHARED_API float get_AspectRatio() const;
    ASPOSE_BARCODE_SHARED_API void set_AspectRatio(float value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    DataBarParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(DataBarParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    
private:

    float _aspectRatio;
    bool pr_Is2DCompositeComponent;
    bool pr_IsAllowOnlyGS1Encoding;
    int32_t pr_Columns;
    int32_t pr_Rows;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS GS1CompositeBarParameters : public System::Object
{
    typedef GS1CompositeBarParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<BaseEncodeType> get_LinearComponentType() const;
    ASPOSE_BARCODE_SHARED_API void set_LinearComponentType(System::SharedPtr<BaseEncodeType> value);
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::TwoDComponentType get_TwoDComponentType() const;
    ASPOSE_BARCODE_SHARED_API void set_TwoDComponentType(Aspose::BarCode::Generation::TwoDComponentType value);
    ASPOSE_BARCODE_SHARED_API bool get_IsAllowOnlyGS1Encoding() const;
    ASPOSE_BARCODE_SHARED_API void set_IsAllowOnlyGS1Encoding(bool value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    GS1CompositeBarParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(GS1CompositeBarParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<BaseEncodeType> pr_LinearComponentType;
    Aspose::BarCode::Generation::TwoDComponentType pr_TwoDComponentType;
    bool pr_IsAllowOnlyGS1Encoding;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS AustralianPostParameters : public System::Object
{
    typedef AustralianPostParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Unit> get_AustralianPostShortBarHeight() const;
    ASPOSE_BARCODE_SHARED_API void set_AustralianPostShortBarHeight(System::SharedPtr<Unit> value);
    ASPOSE_BARCODE_SHARED_API CustomerInformationInterpretingType get_AustralianPostEncodingTable() const;
    ASPOSE_BARCODE_SHARED_API void set_AustralianPostEncodingTable(CustomerInformationInterpretingType value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    AustralianPostParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(AustralianPostParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<Unit> pr_AustralianPostShortBarHeight;
    CustomerInformationInterpretingType pr_AustralianPostEncodingTable;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS PostalParameters : public System::Object
{
    typedef PostalParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Unit> get_PostalShortBarHeight() const;
    ASPOSE_BARCODE_SHARED_API void set_PostalShortBarHeight(System::SharedPtr<Unit> value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    PostalParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(PostalParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<Unit> pr_PostalShortBarHeight;
    
    System::String ToString_NonConst();
    
};

class ASPOSE_BARCODE_SHARED_CLASS PatchCodeParameters : public System::Object
{
    typedef PatchCodeParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API System::String get_ExtraBarcodeText() const;
    ASPOSE_BARCODE_SHARED_API void set_ExtraBarcodeText(System::String value);
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::PatchFormat get_PatchFormat() const;
    ASPOSE_BARCODE_SHARED_API void set_PatchFormat(Aspose::BarCode::Generation::PatchFormat value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    PatchCodeParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(PatchCodeParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::String pr_ExtraBarcodeText;
    Aspose::BarCode::Generation::PatchFormat pr_PatchFormat;
    
    System::String ToString_NonConst();
    
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose


