#pragma once
// Copyright (c) 2001-2025 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <drawing/color.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace ComplexBarcode
{
class ComplexBarcodeGenerator;
} // namespace ComplexBarcode
namespace Generation
{
enum class AutoSizeMode;
class BarcodeGenerator;
class BarcodeParameters;
class BaseRenderer;
class BorderParameters;
class CaptionParameters;
class CMYKColor;
class ImageParameters;
namespace ParamsSpecification
{
class AustralianPosteParcelParamsSpecification;
class AustraliaPostParamsSpecification;
class AztecParamsSpecification;
class CodablockFParamsSpecification;
class Code128ParamsSpecification;
class Code16KParamsSpecification;
class Code32ParamsSpecification;
class DatabarExpandedStackedParamsSpecification;
class DatabarParamsSpecification;
class DatabarStackedOmniDirectionalParamsSpecification;
class DataMatrixParamsSpecification;
class DeutschePostIdentcodeParamsSpecification;
class DeutschePostLeitcodeParamsSpecification;
class DotCodeParamsSpecification;
class EAN13ParamsSpecification;
class EAN14ParamsSpecification;
class EAN8ParamsSpecification;
class GS1AztecParamsSpecification;
class GS1CodablockFParamsSpecification;
class GS1Code128ParamsSpecification;
class GS1CompositeBarParamsSpecification;
class GS1DataMatrixParamsSpecification;
class GS1DotCodeParamsSpecification;
class GS1For2DParamsSpecification;
class GS1HanXinParamsSpecification;
class GS1MicroPdf417ParamsSpecification;
class HanXinParamsSpecification;
class HIBCLICFor1DParamsSpecification;
class HIBCLICFor2DParamsSpecification;
class HIBCPASFor1DParamsSpecification;
class HIBCPASFor2DParamsSpecification;
class Interleaved2of5ParamsSpecification;
class ISBNParamsSpecification;
class ISMNParamsSpecification;
class ISSNParamsSpecification;
class ITF14ParamsSpecification;
class ITF6ParamsSpecification;
class MailmarkParamsSpecification;
class MaxiCodeParamsSpecification;
class MicroPdf417ParamsSpecification;
class OneCodeParamsSpecification;
class OneDParamsSpecification;
class OPCParamsSpecification;
class ParamsSpecificationFactory;
class PatchCodeParamsSpecification;
class Pdf417ParamsSpecification;
class PharmacodeParamsSpecification;
class PZNParamsSpecification;
class RM4SCCParamsSpecification;
class SCC14ParamsSpecification;
class SingaporePostParamsSpecification;
class SSCC18ParamsSpecification;
class SwissPostParcelParamsSpecification;
class TwoDParamsSpecification;
class UpcaGs1Code128CouponParamsSpecification;
class UpcaGs1DatabarCouponParamsSpecification;
class UPCAParamsSpecification;
class UPCEParamsSpecification;
class VINParamsSpecification;
} // namespace ParamsSpecification
class Unit;
} // namespace Generation
class ILicenseChecker;
namespace Serialization
{
namespace Xml
{
class BaseGenerationParametersParser;
} // namespace Xml
} // namespace Serialization
class WatermarkKeeper;
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace Generation {

class ASPOSE_BARCODE_SHARED_CLASS BaseGenerationParameters : public System::Object
{
    typedef BaseGenerationParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeGenerator;
    friend class Aspose::BarCode::Generation::ParamsSpecification::AustralianPosteParcelParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Code128ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::AustraliaPostParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::AztecParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::TwoDParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::OneDParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::CodablockFParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Code16KParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Code32ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DatabarParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DatabarExpandedStackedParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DatabarStackedOmniDirectionalParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DataMatrixParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1DataMatrixParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1For2DParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DeutschePostIdentcodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Interleaved2of5ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DeutschePostLeitcodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DotCodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::EAN13ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::EAN14ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1Code128ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::EAN8ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1AztecParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1CodablockFParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1CompositeBarParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1DotCodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1HanXinParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::HanXinParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1MicroPdf417ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::MicroPdf417ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::HIBCLICFor1DParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::HIBCLICFor2DParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::HIBCPASFor1DParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::HIBCPASFor2DParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ISBNParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ISMNParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ISSNParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ITF14ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ITF6ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::MailmarkParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::RM4SCCParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::MaxiCodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Pdf417ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::OneCodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::OPCParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ParamsSpecificationFactory;
    friend class Aspose::BarCode::Generation::ParamsSpecification::PatchCodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::PharmacodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::PZNParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::SCC14ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::SSCC18ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::SingaporePostParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::SwissPostParcelParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::UpcaGs1Code128CouponParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::UPCAParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::UpcaGs1DatabarCouponParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::UPCEParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::VINParamsSpecification;
    friend class Aspose::BarCode::Generation::BaseRenderer;
    friend class Aspose::BarCode::Serialization::Xml::BaseGenerationParametersParser;
    friend class Aspose::BarCode::ComplexBarcode::ComplexBarcodeGenerator;
    
public:

    ASPOSE_BARCODE_SHARED_API bool get_UseAntiAlias() const;
    ASPOSE_BARCODE_SHARED_API void set_UseAntiAlias(bool value);
    ASPOSE_BARCODE_SHARED_API System::Drawing::Color get_BackColor() const;
    ASPOSE_BARCODE_SHARED_API void set_BackColor(System::Drawing::Color value);
    ASPOSE_BARCODE_SHARED_API float get_Resolution() const;
    ASPOSE_BARCODE_SHARED_API void set_Resolution(float value);
    ASPOSE_BARCODE_SHARED_API float get_RotationAngle() const;
    ASPOSE_BARCODE_SHARED_API void set_RotationAngle(float value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<CaptionParameters> get_CaptionAbove() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<CaptionParameters> get_CaptionBelow() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<ImageParameters> get_Image() const;
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::AutoSizeMode get_AutoSizeMode() const;
    ASPOSE_BARCODE_SHARED_API void set_AutoSizeMode(Aspose::BarCode::Generation::AutoSizeMode value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Unit> get_ImageHeight() const;
    ASPOSE_BARCODE_SHARED_API void set_ImageHeight(System::SharedPtr<Unit> value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Unit> get_ImageWidth() const;
    ASPOSE_BARCODE_SHARED_API void set_ImageWidth(System::SharedPtr<Unit> value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<BarcodeParameters> get_Barcode() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<BorderParameters> get_Border() const;
    
protected:

    System::SharedPtr<CMYKColor> get_CMYKBackColor() const;
    void set_CMYKBackColor(System::SharedPtr<CMYKColor> value);
    float get_RotationAngleInternal();
    ASPOSE_BARCODE_SHARED_API void set_CaptionAbove(System::SharedPtr<CaptionParameters> value);
    ASPOSE_BARCODE_SHARED_API void set_CaptionBelow(System::SharedPtr<CaptionParameters> value);
    ASPOSE_BARCODE_SHARED_API void set_Image(System::SharedPtr<ImageParameters> value);
    ASPOSE_BARCODE_SHARED_API void set_Barcode(System::SharedPtr<BarcodeParameters> value);
    ASPOSE_BARCODE_SHARED_API void set_Border(System::SharedPtr<BorderParameters> value);
    System::SharedPtr<ILicenseChecker> get_LicCheck() const;
    System::SharedPtr<WatermarkKeeper> get_Watermark() const;
    void set_Watermark(System::SharedPtr<WatermarkKeeper> value);
    
    BaseGenerationParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(BaseGenerationParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    static System::String _watermark_text;
    System::SharedPtr<ILicenseChecker> _iLicenseChecker;
    float _resolution;
    float _rotationAngle;
    bool _useAntiAlias;
    System::Drawing::Color _backColor;
    System::SharedPtr<CMYKColor> _cmykBackColor;
    System::SharedPtr<CaptionParameters> pr_CaptionAbove;
    System::SharedPtr<CaptionParameters> pr_CaptionBelow;
    System::SharedPtr<ImageParameters> pr_Image;
    Aspose::BarCode::Generation::AutoSizeMode pr_AutoSizeMode;
    System::SharedPtr<Unit> pr_ImageHeight;
    System::SharedPtr<Unit> pr_ImageWidth;
    System::SharedPtr<BarcodeParameters> pr_Barcode;
    System::SharedPtr<BorderParameters> pr_Border;
    System::SharedPtr<WatermarkKeeper> pr_Watermark;
    
    bool ignoreRotation();
    void UpdateResolution(float dpi);
    
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose


