#pragma once
// Copyright (c) 2001-2022 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <drawing/color.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace Generation
{
class BaseGenerationParameters;
class BaseRenderer;
enum class BorderDashStyle;
class Unit;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace Generation {

class ASPOSE_BARCODE_SHARED_CLASS BorderParameters : public System::Object
{
    typedef BorderParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BaseGenerationParameters;
    friend class Aspose::BarCode::Generation::BaseRenderer;
    
public:

    ASPOSE_BARCODE_SHARED_API bool get_Visible() const;
    ASPOSE_BARCODE_SHARED_API void set_Visible(bool value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Unit> get_Width() const;
    ASPOSE_BARCODE_SHARED_API void set_Width(System::SharedPtr<Unit> value);
    ASPOSE_BARCODE_SHARED_API BorderDashStyle get_DashStyle() const;
    ASPOSE_BARCODE_SHARED_API void set_DashStyle(BorderDashStyle value);
    ASPOSE_BARCODE_SHARED_API System::Drawing::Color get_Color() const;
    ASPOSE_BARCODE_SHARED_API void set_Color(System::Drawing::Color value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    BorderParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(BorderParameters, CODEPORTING_ARGS());
    int32_t GetWidthPx();
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    bool pr_Visible;
    System::SharedPtr<Unit> pr_Width;
    BorderDashStyle pr_DashStyle;
    System::Drawing::Color pr_Color;
    
    System::String ToString_NonConst();
    
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose


