#pragma once
// Copyright (c) 2001-2025 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <drawing/color.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace Generation
{
class BarcodeGenerator;
class BaseGenerationParameters;
class BaseRenderer;
class CaptionRenderer;
class CMYKColor;
class FontUnit;
class Padding;
enum class TextAlignment;
} // namespace Generation
namespace Serialization
{
namespace Xml
{
class CaptionParametersParser;
} // namespace Xml
} // namespace Serialization
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace Generation {

class ASPOSE_BARCODE_SHARED_CLASS CaptionParameters : public System::Object
{
    typedef CaptionParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeGenerator;
    friend class Aspose::BarCode::Generation::BaseGenerationParameters;
    friend class Aspose::BarCode::Generation::BaseRenderer;
    friend class Aspose::BarCode::Generation::CaptionRenderer;
    friend class Aspose::BarCode::Serialization::Xml::CaptionParametersParser;
    
public:

    ASPOSE_BARCODE_SHARED_API System::String get_Text() const;
    ASPOSE_BARCODE_SHARED_API void set_Text(System::String value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<FontUnit> get_Font() const;
    ASPOSE_BARCODE_SHARED_API bool get_Visible() const;
    ASPOSE_BARCODE_SHARED_API void set_Visible(bool value);
    ASPOSE_BARCODE_SHARED_API System::Drawing::Color get_TextColor() const;
    ASPOSE_BARCODE_SHARED_API void set_TextColor(System::Drawing::Color value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Aspose::BarCode::Generation::Padding> get_Padding() const;
    ASPOSE_BARCODE_SHARED_API void set_Padding(System::SharedPtr<Aspose::BarCode::Generation::Padding> value);
    ASPOSE_BARCODE_SHARED_API TextAlignment get_Alignment() const;
    ASPOSE_BARCODE_SHARED_API void set_Alignment(TextAlignment value);
    ASPOSE_BARCODE_SHARED_API bool get_NoWrap() const;
    ASPOSE_BARCODE_SHARED_API void set_NoWrap(bool value);
    
protected:

    ASPOSE_BARCODE_SHARED_API void set_Font(System::SharedPtr<FontUnit> value);
    System::SharedPtr<CMYKColor> get_CMYKTextColor() const;
    void set_CMYKTextColor(System::SharedPtr<CMYKColor> value);
    
    CaptionParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(CaptionParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::String pr_Text;
    System::SharedPtr<FontUnit> pr_Font;
    bool pr_Visible;
    System::Drawing::Color pr_TextColor;
    System::SharedPtr<CMYKColor> pr_CMYKTextColor;
    System::SharedPtr<Aspose::BarCode::Generation::Padding> pr_Padding;
    TextAlignment pr_Alignment;
    bool pr_NoWrap;
    
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose


