#pragma once
// Copyright (c) 2001-2024 Aspose Pty Ltd. All Rights Reserved.

#include <system/object.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace Generation
{
class BaseGenerationParameters;
class PdfParameters;
class SvgParameters;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace Generation {

class ASPOSE_BARCODE_SHARED_CLASS ImageParameters : public System::Object
{
    typedef ImageParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BaseGenerationParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<SvgParameters> get_Svg() const;
    ASPOSE_BARCODE_SHARED_API void set_Svg(System::SharedPtr<SvgParameters> value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<PdfParameters> get_Pdf() const;
    ASPOSE_BARCODE_SHARED_API void set_Pdf(System::SharedPtr<PdfParameters> value);
    
protected:

    ImageParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(ImageParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<SvgParameters> pr_Svg;
    System::SharedPtr<PdfParameters> pr_Pdf;
    
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose


