#pragma once
// Copyright (c) 2001-2021 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace Generation
{
class BarcodeParameters;
class BaseGenerationParameters;
class CaptionParameters;
class Unit;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace Generation {

class ASPOSE_BARCODE_SHARED_CLASS Padding : public System::Object
{
    typedef Padding ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    friend class Aspose::BarCode::Generation::BaseGenerationParameters;
    friend class Aspose::BarCode::Generation::CaptionParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Unit> get_Top() const;
    ASPOSE_BARCODE_SHARED_API void set_Top(System::SharedPtr<Unit> value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Unit> get_Bottom() const;
    ASPOSE_BARCODE_SHARED_API void set_Bottom(System::SharedPtr<Unit> value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Unit> get_Right() const;
    ASPOSE_BARCODE_SHARED_API void set_Right(System::SharedPtr<Unit> value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Unit> get_Left() const;
    ASPOSE_BARCODE_SHARED_API void set_Left(System::SharedPtr<Unit> value);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    Padding();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Padding, CODEPORTING_ARGS());
    int32_t GetStateHash();
    void UpdateResolution(float dpi);
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<Unit> pr_Top;
    System::SharedPtr<Unit> pr_Bottom;
    System::SharedPtr<Unit> pr_Right;
    System::SharedPtr<Unit> pr_Left;
    
    System::String ToString_NonConst();
    
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose


