#pragma once

#include <system/object_ext.h>
#include <system/enum.h>

#include "aspose_barcode_api_defs.h"

namespace Aspose {

namespace BarCode {

namespace Generation {

class PatchcodeConst
{
    typedef PatchcodeConst ThisType;
    
public:

    static float A4_WIDTH_MM;
    static float A4_HEIGHT_MM;
    static float A4_WIDTH_MM_LANDSCAPE;
    static float A4_HEIGHT_MM_LANDSCAPE;
    static float US_LETTER_WIDTH_MM;
    static float US_LETTER_HEIGHT_MM;
    static float US_LETTER_WIDTH_MM_LANDSCAPE;
    static float US_LETTER_HEIGHT_MM_LANDSCAPE;
    
public:
    PatchcodeConst() = delete;
};

enum class PatchFormat
{
    PatchOnly,
    A4,
    A4_LANDSCAPE,
    US_Letter,
    US_Letter_LANDSCAPE
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose

template<>
struct EnumMetaInfo<Aspose::BarCode::Generation::PatchFormat>
{
    static const ASPOSE_BARCODE_SHARED_API std::array<std::pair<Aspose::BarCode::Generation::PatchFormat, const char_t*>, 5>& values();
};



