#pragma once
// Copyright (c) 2001-2025 Aspose Pty Ltd. All Rights Reserved.

#include <system/object.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace Generation
{
class CMYKColor;
class ImageParameters;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace Generation {

class ASPOSE_BARCODE_SHARED_CLASS PdfParameters : public System::Object
{
    typedef PdfParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::ImageParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<CMYKColor> get_CMYKBarColor() const;
    ASPOSE_BARCODE_SHARED_API void set_CMYKBarColor(System::SharedPtr<CMYKColor> value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<CMYKColor> get_CMYKBackColor() const;
    ASPOSE_BARCODE_SHARED_API void set_CMYKBackColor(System::SharedPtr<CMYKColor> value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<CMYKColor> get_CMYKCodetextColor() const;
    ASPOSE_BARCODE_SHARED_API void set_CMYKCodetextColor(System::SharedPtr<CMYKColor> value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<CMYKColor> get_CMYKCaptionAboveColor() const;
    ASPOSE_BARCODE_SHARED_API void set_CMYKCaptionAboveColor(System::SharedPtr<CMYKColor> value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<CMYKColor> get_CMYKCaptionBelowColor() const;
    ASPOSE_BARCODE_SHARED_API void set_CMYKCaptionBelowColor(System::SharedPtr<CMYKColor> value);
    
protected:

    PdfParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(PdfParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<CMYKColor> pr_CMYKBarColor;
    System::SharedPtr<CMYKColor> pr_CMYKBackColor;
    System::SharedPtr<CMYKColor> pr_CMYKCodetextColor;
    System::SharedPtr<CMYKColor> pr_CMYKCaptionAboveColor;
    System::SharedPtr<CMYKColor> pr_CMYKCaptionBelowColor;
    
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose


