#pragma once
// Copyright (c) 2001-2024 Aspose Pty Ltd. All Rights Reserved.

#include <system/object_ext.h>
#include <system/enum.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace Generation
{
class ImageParameters;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace Generation {

enum class SvgColorMode
{
    RGB = 0,
    RGBA = 1,
    HSL = 2,
    HSLA = 3
};

class ASPOSE_BARCODE_SHARED_CLASS SvgParameters : public System::Object
{
    typedef SvgParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::ImageParameters;
    
public:

    ASPOSE_BARCODE_SHARED_API bool get_IsExplicitSizeInPixels() const;
    ASPOSE_BARCODE_SHARED_API void set_IsExplicitSizeInPixels(bool value);
    ASPOSE_BARCODE_SHARED_API bool get_IsTextDrawnInTextElement() const;
    ASPOSE_BARCODE_SHARED_API void set_IsTextDrawnInTextElement(bool value);
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::SvgColorMode get_SvgColorMode() const;
    ASPOSE_BARCODE_SHARED_API void set_SvgColorMode(Aspose::BarCode::Generation::SvgColorMode value);
    
protected:

    SvgParameters();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(SvgParameters, CODEPORTING_ARGS());
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    bool pr_IsExplicitSizeInPixels;
    bool pr_IsTextDrawnInTextElement;
    Aspose::BarCode::Generation::SvgColorMode pr_SvgColorMode;
    
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose

template<>
struct EnumMetaInfo<Aspose::BarCode::Generation::SvgColorMode>
{
    static const ASPOSE_BARCODE_SHARED_API std::array<std::pair<Aspose::BarCode::Generation::SvgColorMode, const char_t*>, 4>& values();
};



