#pragma once
// Copyright (c) 2001-2022 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <system/enum_helpers.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace Generation
{
class BarcodeGenerator;
class BaseRenderer;
class CaptionParameters;
class CaptionRenderer;
class CodetextParameters;
class CodetextRenderer;
namespace ParamsSpecification
{
class Code128ParamsSpecification;
class DotCodeParamsSpecification;
class EAN13ParamsSpecification;
class HanXinParamsSpecification;
class Interleaved2of5ParamsSpecification;
class ITF14ParamsSpecification;
class MaxiCodeParamsSpecification;
class PatchCodeParamsSpecification;
class SSCC18ParamsSpecification;
} // namespace ParamsSpecification
class RendererFactory;
class SimpleBarcodeRenderer;
class Unit;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose
namespace System
{
namespace Drawing
{
class Font;
enum class FontStyle;
enum class GraphicsUnit;
} // namespace Drawing
} // namespace System

namespace Aspose {

namespace BarCode {

namespace Generation {

class ASPOSE_BARCODE_SHARED_CLASS FontUnit final : public System::Object
{
    typedef FontUnit ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeGenerator;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Code128ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Interleaved2of5ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DotCodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::EAN13ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::HanXinParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ITF14ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::MaxiCodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::PatchCodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::SSCC18ParamsSpecification;
    friend class Aspose::BarCode::Generation::CaptionParameters;
    friend class Aspose::BarCode::Generation::CodetextParameters;
    friend class Aspose::BarCode::Generation::SimpleBarcodeRenderer;
    friend class Aspose::BarCode::Generation::BaseRenderer;
    friend class Aspose::BarCode::Generation::RendererFactory;
    friend class Aspose::BarCode::Generation::CaptionRenderer;
    friend class Aspose::BarCode::Generation::CodetextRenderer;
    
public:

    ASPOSE_BARCODE_SHARED_API System::String get_FamilyName() const;
    ASPOSE_BARCODE_SHARED_API void set_FamilyName(System::String value);
    ASPOSE_BARCODE_SHARED_API System::Drawing::FontStyle get_Style() const;
    ASPOSE_BARCODE_SHARED_API void set_Style(System::Drawing::FontStyle value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Unit> get_Size() const;
    
protected:

    System::SharedPtr<System::Drawing::Font> get_Font();
    
    FontUnit(System::SharedPtr<FontUnit> source);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(FontUnit, CODEPORTING_ARGS(System::SharedPtr<FontUnit> source));
    
    FontUnit(System::String familyName, float sizeValue, System::Drawing::GraphicsUnit graphicsUnit, float dpi);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(FontUnit, CODEPORTING_ARGS(System::String familyName, float sizeValue, System::Drawing::GraphicsUnit graphicsUnit, float dpi));
    
    FontUnit(System::String familyName, System::SharedPtr<Unit> size);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(FontUnit, CODEPORTING_ARGS(System::String familyName, System::SharedPtr<Unit> size));
    
    FontUnit(System::String familyName, float sizeValue, System::Drawing::GraphicsUnit graphicsUnit, float dpi, System::Drawing::FontStyle style);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(FontUnit, CODEPORTING_ARGS(System::String familyName, float sizeValue, System::Drawing::GraphicsUnit graphicsUnit, float dpi, System::Drawing::FontStyle style));
    int32_t GetStateHash();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::String _familyName;
    System::SharedPtr<Unit> _size;
    System::Drawing::FontStyle _style;
    
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose


