#pragma once

#include <system/object.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace Drawing
{
class SvgColor;
} // namespace Drawing
namespace Generation
{
class HslaColor;
enum class SvgColorMode;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose
namespace System
{
namespace Drawing
{
class Color;
} // namespace Drawing
class String;
} // namespace System

namespace Aspose {

namespace BarCode {

namespace Generation {

class SvgColorUtils : public System::Object
{
    typedef SvgColorUtils ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    RTTI_INFO_DECL();
    
public:

    static System::String ConvertSvgColorToFillAttribute(System::SharedPtr<Aspose::BarCode::Drawing::SvgColor> color, SvgColorMode colorMode);
    
private:

    static System::SharedPtr<HslaColor> ConvertRgbaToHsla(System::Drawing::Color rgbaColor);
    static float GetHue(float redF, float greenF, float blueF, float max, float min);
    static float GetSaturation(float redF, float greenF, float blueF, float max, float min);
    
};

class ASPOSE_BARCODE_SHARED_CLASS HslaColor : public System::Object
{
    typedef HslaColor ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    int32_t H;
    int32_t S;
    int32_t L;
    float A;
    
    ASPOSE_BARCODE_SHARED_API HslaColor(int32_t h, int32_t s, int32_t l, float a);
    
    static ASPOSE_BARCODE_SHARED_API System::Drawing::Color ConvertHslaToRgba(System::SharedPtr<HslaColor> hslaColor);
    
private:

    static void CheckHue(int32_t value);
    static void CheckSatLight(int32_t value);
    static void CheckAlpha(float value);
    static float HueToRgb(float p, float q, float t);
    
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose


