#pragma once
// Copyright (c) 2001-2021 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace Generation
{
class BarcodeGenerator;
class BarcodeParameters;
class BaseGenerationParameters;
class BaseRenderer;
class BorderParameters;
class CaptionRenderer;
class CodetextParameters;
class CodetextRenderer;
class CoreImageParameters;
class CouponParameters;
class FontUnit;
namespace Helpers
{
class IUnitValidator;
} // namespace Helpers
class ITFRenderer;
class Padding;
namespace ParamsSpecification
{
class AustralianPosteParcelParamsSpecification;
class AustraliaPostParamsSpecification;
class AztecParamsSpecification;
class CodabarParamsSpecification;
class CodablockFParamsSpecification;
class Code11ParamsSpecification;
class Code128ParamsSpecification;
class Code16KParamsSpecification;
class Code32ParamsSpecification;
class Code39ExtendedParamsSpecification;
class Code39ParamsSpecification;
class Code93ExtendedParamsSpecification;
class DatabarExpandedParamsSpecification;
class DatabarExpandedStackedParamsSpecification;
class DatabarLimitedParamsSpecification;
class DatabarOmniDirectionalParamsSpecification;
class DatabarStackedOmniDirectionalParamsSpecification;
class DatabarStackedParamsSpecification;
class DatabarTruncatedParamsSpecification;
class DataLogic2of5ParamsSpecification;
class DataMatrixParamsSpecification;
class DeutschePostIdentcodeParamsSpecification;
class DeutschePostLeitcodeParamsSpecification;
class DotCodeParamsSpecification;
class DutchKIXParamsSpecification;
class EAN13ParamsSpecification;
class EAN14ParamsSpecification;
class EAN8ParamsSpecification;
class GS1CodablockFParamsSpecification;
class GS1Code128ParamsSpecification;
class GS1CompositeBarParamsSpecification;
class GS1DataMatrixParamsSpecification;
class GS1QRParamsSpecification;
class HanXinParamsSpecification;
class HIBCLICFor1DParamsSpecification;
class HIBCLICFor2DParamsSpecification;
class HIBCPASFor1DParamsSpecification;
class HIBCPASFor2DParamsSpecification;
class IATA2of5ParamsSpecification;
class Interleaved2of5ParamsSpecification;
class ISBNParamsSpecification;
class ISMNParamsSpecification;
class ISSNParamsSpecification;
class ITF14ParamsSpecification;
class ITF6ParamsSpecification;
class Matrix2of5ParamsSpecification;
class MaxiCodeParamsSpecification;
class MicroPdf417ParamsSpecification;
class MicroQRParamsSpecification;
class MSIParamsSpecification;
class OneCodeParamsSpecification;
class OneDParamsSpecification;
class OPCParamsSpecification;
class PatchCodeParamsSpecification;
class Pdf417ParamsSpecification;
class PharmacodeParamsSpecification;
class PostalParamsSpecification;
class PZNParamsSpecification;
class QRParamsSpecification;
class RectMicroQRParamsSpecification;
class RM4SCCParamsSpecification;
class SCC14ParamsSpecification;
class SingaporePostParamsSpecification;
class SSCC18ParamsSpecification;
class Standard2of5ParamsSpecification;
class SwissPostParcelParamsSpecification;
class TwoDParamsSpecification;
class UpcaGs1Code128CouponParamsSpecification;
class UpcaGs1DatabarCouponParamsSpecification;
class UPCAParamsSpecification;
class UPCEParamsSpecification;
class VINParamsSpecification;
} // namespace ParamsSpecification
class RendererFactory;
class SupplementParameters;
} // namespace Generation
namespace Serialization
{
namespace Xml
{
class UnitParser;
} // namespace Xml
} // namespace Serialization
} // namespace BarCode
} // namespace Aspose
namespace System
{
namespace Drawing
{
enum class GraphicsUnit;
} // namespace Drawing
} // namespace System

namespace Aspose {

namespace BarCode {

namespace Generation {

class ASPOSE_BARCODE_SHARED_CLASS Unit final : public System::Object
{
    typedef Unit ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::BarcodeGenerator;
    friend class Aspose::BarCode::Generation::BarcodeParameters;
    friend class Aspose::BarCode::Generation::CouponParameters;
    friend class Aspose::BarCode::Generation::SupplementParameters;
    friend class Aspose::BarCode::Generation::ParamsSpecification::AustralianPosteParcelParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Code128ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::AustraliaPostParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::AztecParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::TwoDParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::CodabarParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::OneDParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::CodablockFParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Code11ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Code16KParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Code32ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Code39ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Code39ExtendedParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Code93ExtendedParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DatabarExpandedStackedParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DatabarStackedOmniDirectionalParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DatabarOmniDirectionalParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DatabarTruncatedParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DatabarExpandedParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DatabarLimitedParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DatabarStackedParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DataLogic2of5ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DataMatrixParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1DataMatrixParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DeutschePostIdentcodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Interleaved2of5ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DeutschePostLeitcodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DotCodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::DutchKIXParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::EAN13ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::EAN14ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1Code128ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::EAN8ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1CodablockFParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1CompositeBarParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::HanXinParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::MicroPdf417ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::HIBCLICFor1DParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::HIBCLICFor2DParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::HIBCPASFor1DParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::HIBCPASFor2DParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::IATA2of5ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ISBNParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ISMNParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ISSNParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ITF14ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::ITF6ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::RM4SCCParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Matrix2of5ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::MaxiCodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Pdf417ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::MicroQRParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::MSIParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::OneCodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::OPCParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::PatchCodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::PharmacodeParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::PostalParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::PZNParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::QRParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::GS1QRParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::RectMicroQRParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::SCC14ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::SSCC18ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::SingaporePostParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::Standard2of5ParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::SwissPostParcelParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::UpcaGs1Code128CouponParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::UPCAParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::UpcaGs1DatabarCouponParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::UPCEParamsSpecification;
    friend class Aspose::BarCode::Generation::ParamsSpecification::VINParamsSpecification;
    friend class Aspose::BarCode::Generation::BaseGenerationParameters;
    friend class Aspose::BarCode::Generation::BorderParameters;
    friend class Aspose::BarCode::Generation::CodetextParameters;
    friend class Aspose::BarCode::Generation::CoreImageParameters;
    friend class Aspose::BarCode::Generation::Padding;
    friend class Aspose::BarCode::Generation::FontUnit;
    friend class Aspose::BarCode::Generation::ITFRenderer;
    friend class Aspose::BarCode::Generation::BaseRenderer;
    friend class Aspose::BarCode::Generation::RendererFactory;
    friend class Aspose::BarCode::Generation::CaptionRenderer;
    friend class Aspose::BarCode::Generation::CodetextRenderer;
    friend class Aspose::BarCode::Serialization::Xml::UnitParser;
    
public:

    ASPOSE_BARCODE_SHARED_API float get_Pixels();
    ASPOSE_BARCODE_SHARED_API void set_Pixels(float value);
    ASPOSE_BARCODE_SHARED_API float get_Inches();
    ASPOSE_BARCODE_SHARED_API void set_Inches(float value);
    ASPOSE_BARCODE_SHARED_API float get_Millimeters();
    ASPOSE_BARCODE_SHARED_API void set_Millimeters(float value);
    ASPOSE_BARCODE_SHARED_API float get_Point();
    ASPOSE_BARCODE_SHARED_API void set_Point(float value);
    ASPOSE_BARCODE_SHARED_API float get_Document();
    ASPOSE_BARCODE_SHARED_API void set_Document(float value);
    ASPOSE_BARCODE_SHARED_API float get_Resolution() const;
    
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<System::Object> obj) override;
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    static float DefaultDpi;
    float _dpi;
    System::Drawing::GraphicsUnit _graphicsUnit;
    float _units;
    
    int32_t get_Px() const;
    float get_Display();
    void set_Display(float value);
    float get_World();
    void set_World(float value);
    System::Drawing::GraphicsUnit get_GraphicsUnit() const;
    void set_GraphicsUnit(System::Drawing::GraphicsUnit value);
    float get_Units() const;
    void set_Units(float value);
    
    void SetValidator(System::SharedPtr<Helpers::IUnitValidator> validator);
    
    Unit(float value, System::Drawing::GraphicsUnit graphicsUnit);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Unit, CODEPORTING_ARGS(float value, System::Drawing::GraphicsUnit graphicsUnit));
    
    Unit(float value, System::Drawing::GraphicsUnit graphicsUnit, float dpi);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Unit, CODEPORTING_ARGS(float value, System::Drawing::GraphicsUnit graphicsUnit, float dpi));
    
    Unit(System::SharedPtr<Unit> source);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Unit, CODEPORTING_ARGS(System::SharedPtr<Unit> source));
    void UpdateResolution(float dpi);
    float ToCurrentGraphicsUnit(System::Drawing::GraphicsUnit graphicsUnit);
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<Helpers::IUnitValidator> _validator;
    
    ASPOSE_BARCODE_SHARED_API void set_Resolution(float value);
    
    System::String ToString_NonConst();
    bool Validate(float value);
    void CheckDpi(float dpi, System::String name);
    
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose


