#pragma once
//-----------------------------------------------------------------------------------------------------------
// <copyright file="ProcessorSettings.cs" company="Aspose Pty Ltd" author="Alex Baranov" date="9/16/2015 6:30:27 PM">
//     Copyright (c) 2001-2012 Aspose Pty Ltd. All rights reserved.
// </copyright>
//-----------------------------------------------------------------------------------------------------------

#include <system/object.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class BarCodeReader;
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace Common {

class ASPOSE_BARCODE_SHARED_CLASS ProcessorSettings : public System::Object
{
    typedef ProcessorSettings ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::BarCodeReader;
    
public:

    ASPOSE_BARCODE_SHARED_API bool get_UseAllCores() const;
    ASPOSE_BARCODE_SHARED_API void set_UseAllCores(bool value);
    ASPOSE_BARCODE_SHARED_API int32_t get_UseOnlyThisCoresCount() const;
    ASPOSE_BARCODE_SHARED_API void set_UseOnlyThisCoresCount(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_MaxAdditionalAllowedThreads() const;
    ASPOSE_BARCODE_SHARED_API void set_MaxAdditionalAllowedThreads(int32_t value);
    
protected:

    ProcessorSettings(bool useAllCores);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(ProcessorSettings, CODEPORTING_ARGS(bool useAllCores));
    
private:

    bool pr_UseAllCores;
    int32_t pr_UseOnlyThisCoresCount;
    int32_t pr_MaxAdditionalAllowedThreads;
    
};

} // namespace Common
} // namespace BarCode
} // namespace Aspose


