#pragma once
// Copyright (c) 2001-2019 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
namespace Barcode1D
{
class MetaDecoderCode128;
} // namespace Barcode1D
class Code128ExtendedParameters;
enum class Code128SubType;
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS Code128DataPortion : public System::Object
{
    typedef Code128DataPortion ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::Barcode1D::MetaDecoderCode128;
    friend class Aspose::BarCode::BarCodeRecognition::Code128ExtendedParameters;
    friend ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<Code128DataPortion> first, System::SharedPtr<Code128DataPortion> second);
    friend ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<Code128DataPortion> first, System::SharedPtr<Code128DataPortion> second);
    
public:

    ASPOSE_BARCODE_SHARED_API System::String get_Data() const;
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::BarCodeRecognition::Code128SubType get_Code128SubType() const;
    
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    ASPOSE_BARCODE_SHARED_API void set_Data(System::String value);
    ASPOSE_BARCODE_SHARED_API void set_Code128SubType(Aspose::BarCode::BarCodeRecognition::Code128SubType value);
    
    Code128DataPortion(Aspose::BarCode::BarCodeRecognition::Code128SubType code128SubType, System::String data);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Code128DataPortion, CODEPORTING_ARGS(Aspose::BarCode::BarCodeRecognition::Code128SubType code128SubType, System::String data));
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::String pr_Data;
    Aspose::BarCode::BarCodeRecognition::Code128SubType pr_Code128SubType;
    
    System::String ToString_NonConst();
    static bool IsEqual(System::SharedPtr<Code128DataPortion> first, System::SharedPtr<Code128DataPortion> second);
    
};

ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<Code128DataPortion> first, System::SharedPtr<Code128DataPortion> second);
ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<Code128DataPortion> first, System::SharedPtr<Code128DataPortion> second);

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


