#pragma once
//-----------------------------------------------------------------------------------------------------------
// <copyright file="EncodingState.cs" company="Aspose Pty Ltd" author="A. Tyutyunik" date="30.07.2013 14:49:12">
//     Copyright (c) 2001-2011 Aspose Pty Ltd. All rights reserved.
// </copyright>
//-----------------------------------------------------------------------------------------------------------

#include <system/object_ext.h>
#include <system/enum.h>

#include "aspose_barcode_api_defs.h"

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

namespace Recognition {

namespace Pdf417 {

namespace StateHandler {

enum class EncodingState
{
    Start = 0,
    TextLatchMode = 1,
    ByteLatchMode = 2,
    ByteShiftMode = 3,
    NumericLatchMode = 4,
    MacroStart = 5,
    MacroSeparator = 6,
    MacroTerminator = 7,
    ReaderInitialisation = 8,
    ECILatchMode = 9,
    Linked = 10,
    GS1Composite = 11,
    End = -1
};

} // namespace StateHandler
} // namespace Pdf417
} // namespace Recognition
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose

template<>
struct EnumMetaInfo<Aspose::BarCode::BarCodeRecognition::Recognition::Pdf417::StateHandler::EncodingState>
{
    static const ASPOSE_BARCODE_SHARED_API std::array<std::pair<Aspose::BarCode::BarCodeRecognition::Recognition::Pdf417::StateHandler::EncodingState, const char_t*>, 13>& values();
};



