#pragma once
// Copyright (c) 2001-2021 Aspose Pty Ltd. All Rights Reserved.

#include <system/exceptions.h>

#include "aspose_barcode_api_defs.h"

namespace System
{
class String;
} // namespace System

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class Details_BarCodeRecognitionException;
using BarCodeRecognitionException = System::ExceptionWrapper<Details_BarCodeRecognitionException>;

class ASPOSE_BARCODE_SHARED_CLASS Details_BarCodeRecognitionException : public System::Details_Exception
{
    typedef Details_BarCodeRecognitionException ThisType;
    typedef System::Details_Exception BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class System::ExceptionWrapperHelper;
    template <typename T> friend class System::ExceptionWrapper;
    
protected:

    [[noreturn]] void DoThrow(const System::ExceptionPtr& self) const override;
    
    ASPOSE_BARCODE_SHARED_API Details_BarCodeRecognitionException();
    
    ASPOSE_BARCODE_SHARED_API MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Details_BarCodeRecognitionException, CODEPORTING_ARGS());
    
    ASPOSE_BARCODE_SHARED_API Details_BarCodeRecognitionException(System::String message);
    
    ASPOSE_BARCODE_SHARED_API MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Details_BarCodeRecognitionException, CODEPORTING_ARGS(System::String message));
    
    ASPOSE_BARCODE_SHARED_API Details_BarCodeRecognitionException(System::String message, System::Exception innerException);
    
    ASPOSE_BARCODE_SHARED_API MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Details_BarCodeRecognitionException, CODEPORTING_ARGS(System::String message, System::Exception innerException));
    
};

class Details_RecognitionEngineException;
using RecognitionEngineException = System::ExceptionWrapper<Details_RecognitionEngineException>;

class Details_RecognitionEngineException : public Aspose::BarCode::BarCodeRecognition::Details_BarCodeRecognitionException
{
    typedef Details_RecognitionEngineException ThisType;
    typedef Aspose::BarCode::BarCodeRecognition::Details_BarCodeRecognitionException BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    RTTI_INFO_DECL();
    
    friend class System::ExceptionWrapperHelper;
    template <typename T> friend class System::ExceptionWrapper;
    
protected:

    [[noreturn]] void DoThrow(const System::ExceptionPtr& self) const override;
    
    Details_RecognitionEngineException(System::String message);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Details_RecognitionEngineException, CODEPORTING_ARGS(System::String message));
    
    Details_RecognitionEngineException();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Details_RecognitionEngineException, CODEPORTING_ARGS());
    
    Details_RecognitionEngineException(System::Exception ex);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Details_RecognitionEngineException, CODEPORTING_ARGS(System::Exception ex));
    
};

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


