#pragma once
// Copyright (c) 2001-2024 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class AztecExtendedParameters;
class BarCodeResult;
class CodabarExtendedParameters;
class Code128ExtendedParameters;
class CodeResult;
class DataBarExtendedParameters;
class DataMatrixExtendedParameters;
class DotCodeExtendedParameters;
class GS1CompositeBarExtendedParameters;
class MaxiCodeExtendedParameters;
class OneDExtendedParameters;
class Pdf417ExtendedParameters;
class QRExtendedParameters;
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS BarCodeExtendedParameters final : public System::Object
{
    typedef BarCodeExtendedParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::BarCodeResult;
    friend ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<BarCodeExtendedParameters> first, System::SharedPtr<BarCodeExtendedParameters> second);
    friend ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<BarCodeExtendedParameters> first, System::SharedPtr<BarCodeExtendedParameters> second);
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<OneDExtendedParameters> get_OneD() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Code128ExtendedParameters> get_Code128() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<QRExtendedParameters> get_QR() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Pdf417ExtendedParameters> get_Pdf417() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<DataBarExtendedParameters> get_DataBar() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<MaxiCodeExtendedParameters> get_MaxiCode() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<DotCodeExtendedParameters> get_DotCode() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<DataMatrixExtendedParameters> get_DataMatrix() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<AztecExtendedParameters> get_Aztec() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<GS1CompositeBarExtendedParameters> get_GS1CompositeBar() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<CodabarExtendedParameters> get_Codabar() const;
    
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    BarCodeExtendedParameters(System::SharedPtr<CodeResult> aResult);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(BarCodeExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<CodeResult> aResult));
    
    BarCodeExtendedParameters(System::SharedPtr<BarCodeExtendedParameters> aParameters);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(BarCodeExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<BarCodeExtendedParameters> aParameters));
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<OneDExtendedParameters> _oneDParameters;
    System::SharedPtr<Code128ExtendedParameters> _code128Parameters;
    System::SharedPtr<QRExtendedParameters> _qrParameters;
    System::SharedPtr<Pdf417ExtendedParameters> _pdf417Parameters;
    System::SharedPtr<DataBarExtendedParameters> _dataBarParameters;
    System::SharedPtr<MaxiCodeExtendedParameters> _maxiCodeExtendedParameters;
    System::SharedPtr<DotCodeExtendedParameters> _dotCodeExtendedParameters;
    System::SharedPtr<DataMatrixExtendedParameters> _dataMatrixExtendedParameters;
    System::SharedPtr<AztecExtendedParameters> _aztecExtendedParameters;
    System::SharedPtr<GS1CompositeBarExtendedParameters> _gs1CompositeBarExtendedParameters;
    System::SharedPtr<CodabarExtendedParameters> _codabarExtendedParameters;
    
    System::String ToString_NonConst();
    static bool IsEqual(System::SharedPtr<BarCodeExtendedParameters> first, System::SharedPtr<BarCodeExtendedParameters> second);
    
};

ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<BarCodeExtendedParameters> first, System::SharedPtr<BarCodeExtendedParameters> second);
ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<BarCodeExtendedParameters> first, System::SharedPtr<BarCodeExtendedParameters> second);

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


