#pragma once
// Copyright (c) 2001-2022 Aspose Pty Ltd. All Rights Reserved.

#include <system/array.h>
#include <drawing/rectangle.h>
#include <drawing/point.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class BarCodeResult;
class CodeResult;
class Quadrangle;
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS BarCodeRegionParameters final : public System::Object
{
    typedef BarCodeRegionParameters ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::BarCodeResult;
    friend ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<BarCodeRegionParameters> first, System::SharedPtr<BarCodeRegionParameters> second);
    friend ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<BarCodeRegionParameters> first, System::SharedPtr<BarCodeRegionParameters> second);
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Aspose::BarCode::BarCodeRecognition::Quadrangle> get_Quadrangle() const;
    ASPOSE_BARCODE_SHARED_API double get_Angle() const;
    ASPOSE_BARCODE_SHARED_API System::ArrayPtr<System::Drawing::Point> get_Points() const;
    ASPOSE_BARCODE_SHARED_API System::Drawing::Rectangle get_Rectangle() const;
    
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    BarCodeRegionParameters(System::SharedPtr<CodeResult> aResult);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(BarCodeRegionParameters, CODEPORTING_ARGS(System::SharedPtr<CodeResult> aResult));
    
    BarCodeRegionParameters(System::SharedPtr<BarCodeRegionParameters> aRegion);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(BarCodeRegionParameters, CODEPORTING_ARGS(System::SharedPtr<BarCodeRegionParameters> aRegion));
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<Aspose::BarCode::BarCodeRecognition::Quadrangle> _quad;
    double _angle;
    System::ArrayPtr<System::Drawing::Point> _points;
    System::Drawing::Rectangle _rect;
    
    System::String ToString_NonConst();
    static bool IsEqual(System::SharedPtr<BarCodeRegionParameters> first, System::SharedPtr<BarCodeRegionParameters> second);
    
};

ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<BarCodeRegionParameters> first, System::SharedPtr<BarCodeRegionParameters> second);
ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<BarCodeRegionParameters> first, System::SharedPtr<BarCodeRegionParameters> second);

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


