#pragma once
// Copyright (c) 2001-2024 Aspose Pty Ltd. All Rights Reserved.

#include <system/iequatable.h>
#include <system/icloneable.h>
#include <system/array.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
enum class BarCodeConfidence : int32_t;
class BarCodeExtendedParameters;
class BarCodeReaderImplementation;
class BarCodeRegionParameters;
class CodeResult;
class SingleDecodeType;
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose
namespace System
{
namespace Text
{
class Encoding;
} // namespace Text
} // namespace System

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS BarCodeResult final : public System::ICloneable, public System::IEquatable<System::SharedPtr<Aspose::BarCode::BarCodeRecognition::BarCodeResult>>
{
    typedef BarCodeResult ThisType;
    typedef System::ICloneable BaseType;
    typedef System::IEquatable<System::SharedPtr<Aspose::BarCode::BarCodeRecognition::BarCodeResult>> BaseType1;
    
    typedef ::System::BaseTypesInfo<BaseType, BaseType1> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::BarCodeReaderImplementation;
    friend ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<BarCodeResult> first, System::SharedPtr<BarCodeResult> second);
    friend ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<BarCodeResult> first, System::SharedPtr<BarCodeResult> second);
    
public:

    ASPOSE_BARCODE_SHARED_API double get_ReadingQuality() const;
    ASPOSE_BARCODE_SHARED_API BarCodeConfidence get_Confidence() const;
    ASPOSE_BARCODE_SHARED_API System::String get_CodeText() const;
    ASPOSE_BARCODE_SHARED_API System::ArrayPtr<uint8_t> get_CodeBytes() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> get_CodeType() const;
    ASPOSE_BARCODE_SHARED_API System::String get_CodeTypeName();
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<BarCodeRegionParameters> get_Region() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<BarCodeExtendedParameters> get_Extended() const;
    
    ASPOSE_BARCODE_SHARED_API System::String GetCodeText(System::SharedPtr<System::Text::Encoding> encoding);
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<BarCodeResult> other) override;
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<System::Object> Clone() override;
    
    ASPOSE_BARCODE_SHARED_API BarCodeResult(System::SharedPtr<BarCodeResult> result);
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    BarCodeResult(System::SharedPtr<CodeResult> aResult);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(BarCodeResult, CODEPORTING_ARGS(System::SharedPtr<CodeResult> aResult));
    
    virtual ASPOSE_BARCODE_SHARED_API ~BarCodeResult();
    
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    double _readingQuality;
    BarCodeConfidence _confidence;
    System::String _codeText;
    System::ArrayPtr<uint8_t> _codeBytes;
    System::SharedPtr<SingleDecodeType> _codeType;
    System::SharedPtr<BarCodeRegionParameters> _region;
    System::SharedPtr<BarCodeExtendedParameters> _extended;
    
    System::String ToString_NonConst();
    static bool IsEqual(System::SharedPtr<BarCodeResult> first, System::SharedPtr<BarCodeResult> second);
    static bool IsByteArraysEqual(System::ArrayPtr<uint8_t> first, System::ArrayPtr<uint8_t> second);
    static int32_t GetArrayHashCode(System::ArrayPtr<uint8_t> aByteArray);
    BarCodeConfidence CreateConfidence(System::SharedPtr<CodeResult> aResult);
    System::String CreateCodetextWithChecksum(System::SharedPtr<CodeResult> aResult);
    System::ArrayPtr<uint8_t> CreateCodeBytes(System::String aCodetext);
    
};

ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<BarCodeResult> first, System::SharedPtr<BarCodeResult> second);
ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<BarCodeResult> first, System::SharedPtr<BarCodeResult> second);

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


