#pragma once
// Copyright (c) 2001-2024 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <cstdint>

#include "BarCodeRecognition/Recognition/RecognitionSession/BarcodeResults/BaseExtendedParameters.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class BarCodeExtendedParameters;
class CodeResult;
} // namespace BarCodeRecognition
namespace Generation
{
enum class CodabarSymbol : int16_t;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS CodabarExtendedParameters final : public Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters
{
    typedef CodabarExtendedParameters ThisType;
    typedef Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::BarCodeExtendedParameters;
    friend ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<CodabarExtendedParameters> first, System::SharedPtr<CodabarExtendedParameters> second);
    friend ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<CodabarExtendedParameters> first, System::SharedPtr<CodabarExtendedParameters> second);
    
public:

    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::CodabarSymbol get_CodabarStartSymbol() const;
    ASPOSE_BARCODE_SHARED_API void set_CodabarStartSymbol(Aspose::BarCode::Generation::CodabarSymbol value);
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::CodabarSymbol get_CodabarStopSymbol() const;
    ASPOSE_BARCODE_SHARED_API void set_CodabarStopSymbol(Aspose::BarCode::Generation::CodabarSymbol value);
    
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    CodabarExtendedParameters(System::SharedPtr<CodeResult> aResult);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(CodabarExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<CodeResult> aResult));
    
    CodabarExtendedParameters(System::SharedPtr<CodabarExtendedParameters> aParameters);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(CodabarExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<CodabarExtendedParameters> aParameters));
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    Aspose::BarCode::Generation::CodabarSymbol _codabarStartSymbol;
    Aspose::BarCode::Generation::CodabarSymbol _codabarStopSymbol;
    
    System::String ToString_NonConst();
    static bool IsEqual(System::SharedPtr<CodabarExtendedParameters> first, System::SharedPtr<CodabarExtendedParameters> second);
    
};

ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<CodabarExtendedParameters> first, System::SharedPtr<CodabarExtendedParameters> second);
ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<CodabarExtendedParameters> first, System::SharedPtr<CodabarExtendedParameters> second);

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


