#pragma once
// Copyright (c) 2001-2019 Aspose Pty Ltd. All Rights Reserved.

#include <system/array.h>
#include <cstdint>

#include "BarCodeRecognition/Recognition/RecognitionSession/BarcodeResults/BaseExtendedParameters.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class BarCodeExtendedParameters;
class Code128DataPortion;
class CodeResult;
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS Code128ExtendedParameters final : public Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters
{
    typedef Code128ExtendedParameters ThisType;
    typedef Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::BarCodeExtendedParameters;
    friend ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<Code128ExtendedParameters> first, System::SharedPtr<Code128ExtendedParameters> second);
    friend ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<Code128ExtendedParameters> first, System::SharedPtr<Code128ExtendedParameters> second);
    
public:

    ASPOSE_BARCODE_SHARED_API System::ArrayPtr<System::SharedPtr<Code128DataPortion>> get_Code128DataPortions() const;
    
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    Code128ExtendedParameters(System::SharedPtr<CodeResult> aResult);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Code128ExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<CodeResult> aResult));
    
    Code128ExtendedParameters(System::SharedPtr<Code128ExtendedParameters> aParameters);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Code128ExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<Code128ExtendedParameters> aParameters));
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::ArrayPtr<System::SharedPtr<Code128DataPortion>> _code128DataPortions;
    
    System::String ToString_NonConst();
    static bool IsEqual(System::SharedPtr<Code128ExtendedParameters> first, System::SharedPtr<Code128ExtendedParameters> second);
    System::ArrayPtr<System::SharedPtr<Code128DataPortion>> CloneCode128DataPortions(System::ArrayPtr<System::SharedPtr<Code128DataPortion>> aArray);
    
};

ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<Code128ExtendedParameters> first, System::SharedPtr<Code128ExtendedParameters> second);
ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<Code128ExtendedParameters> first, System::SharedPtr<Code128ExtendedParameters> second);

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


