#pragma once
// Copyright (c) 2001-2019 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <cstdint>

#include "BarCodeRecognition/Recognition/RecognitionSession/BarcodeResults/BaseExtendedParameters.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class BarCodeExtendedParameters;
class CodeResult;
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS DataMatrixExtendedParameters final : public Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters
{
    typedef DataMatrixExtendedParameters ThisType;
    typedef Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::BarCodeExtendedParameters;
    friend ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<DataMatrixExtendedParameters> first, System::SharedPtr<DataMatrixExtendedParameters> second);
    friend ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<DataMatrixExtendedParameters> first, System::SharedPtr<DataMatrixExtendedParameters> second);
    
public:

    ASPOSE_BARCODE_SHARED_API int32_t get_StructuredAppendBarcodesCount() const;
    ASPOSE_BARCODE_SHARED_API int32_t get_StructuredAppendBarcodeId() const;
    ASPOSE_BARCODE_SHARED_API int32_t get_StructuredAppendFileId() const;
    ASPOSE_BARCODE_SHARED_API bool get_IsReaderProgramming() const;
    
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    DataMatrixExtendedParameters(System::SharedPtr<CodeResult> aResult);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(DataMatrixExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<CodeResult> aResult));
    
    DataMatrixExtendedParameters(System::SharedPtr<DataMatrixExtendedParameters> aParameters);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(DataMatrixExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<DataMatrixExtendedParameters> aParameters));
    
private:

    int32_t _structuredAppendBarcodesCount;
    int32_t _structuredAppendBarcodeId;
    int32_t _structuredAppendFileId;
    bool _isReaderProgramming;
    
    System::String ToString_NonConst();
    static bool IsEqual(System::SharedPtr<DataMatrixExtendedParameters> first, System::SharedPtr<DataMatrixExtendedParameters> second);
    
};

ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<DataMatrixExtendedParameters> first, System::SharedPtr<DataMatrixExtendedParameters> second);
ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<DataMatrixExtendedParameters> first, System::SharedPtr<DataMatrixExtendedParameters> second);

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


