#pragma once
// Copyright (c) 2001-2019 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <cstdint>

#include "BarCodeRecognition/Recognition/RecognitionSession/BarcodeResults/BaseExtendedParameters.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class BarCodeExtendedParameters;
class CodeResult;
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS DotCodeExtendedParameters final : public Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters
{
    typedef DotCodeExtendedParameters ThisType;
    typedef Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::BarCodeExtendedParameters;
    friend ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<DotCodeExtendedParameters> first, System::SharedPtr<DotCodeExtendedParameters> second);
    friend ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<DotCodeExtendedParameters> first, System::SharedPtr<DotCodeExtendedParameters> second);
    
public:

    ASPOSE_BARCODE_SHARED_API int32_t get_DotCodeStructuredAppendModeBarcodesCount() const;
    ASPOSE_BARCODE_SHARED_API int32_t get_DotCodeStructuredAppendModeBarcodeId() const;
    ASPOSE_BARCODE_SHARED_API bool get_DotCodeIsReaderInitialization() const;
    
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    DotCodeExtendedParameters(System::SharedPtr<CodeResult> aResult);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(DotCodeExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<CodeResult> aResult));
    
    DotCodeExtendedParameters(System::SharedPtr<DotCodeExtendedParameters> aParameters);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(DotCodeExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<DotCodeExtendedParameters> aParameters));
    
private:

    int32_t _dotCodeStructuredAppendModeBarcodesCount;
    int32_t _dotCodeStructuredAppendModeBarcodeId;
    bool _dotCodeIsReaderInitialization;
    
    System::String ToString_NonConst();
    static bool IsEqual(System::SharedPtr<DotCodeExtendedParameters> first, System::SharedPtr<DotCodeExtendedParameters> second);
    
};

ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<DotCodeExtendedParameters> first, System::SharedPtr<DotCodeExtendedParameters> second);
ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<DotCodeExtendedParameters> first, System::SharedPtr<DotCodeExtendedParameters> second);

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


