#pragma once
// Copyright (c) 2001-2024 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <cstdint>

#include "BarCodeRecognition/Recognition/RecognitionSession/BarcodeResults/BaseExtendedParameters.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class BarCodeExtendedParameters;
class CodeResult;
class SingleDecodeType;
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS GS1CompositeBarExtendedParameters final : public Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters
{
    typedef GS1CompositeBarExtendedParameters ThisType;
    typedef Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::BarCodeExtendedParameters;
    friend ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<GS1CompositeBarExtendedParameters> first, System::SharedPtr<GS1CompositeBarExtendedParameters> second);
    friend ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<GS1CompositeBarExtendedParameters> first, System::SharedPtr<GS1CompositeBarExtendedParameters> second);
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> get_OneDType() const;
    ASPOSE_BARCODE_SHARED_API System::String get_OneDCodeText() const;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> get_TwoDType() const;
    ASPOSE_BARCODE_SHARED_API System::String get_TwoDCodeText() const;
    
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    GS1CompositeBarExtendedParameters(System::SharedPtr<CodeResult> aResult);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(GS1CompositeBarExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<CodeResult> aResult));
    
    GS1CompositeBarExtendedParameters(System::SharedPtr<GS1CompositeBarExtendedParameters> aParameters);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(GS1CompositeBarExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<GS1CompositeBarExtendedParameters> aParameters));
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<SingleDecodeType> _oneDType;
    System::String _oneDCodeText;
    System::SharedPtr<SingleDecodeType> _twoDType;
    System::String _twoDCodeText;
    
    System::String ToString_NonConst();
    static bool IsEqual(System::SharedPtr<GS1CompositeBarExtendedParameters> first, System::SharedPtr<GS1CompositeBarExtendedParameters> second);
    
};

ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<GS1CompositeBarExtendedParameters> first, System::SharedPtr<GS1CompositeBarExtendedParameters> second);
ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<GS1CompositeBarExtendedParameters> first, System::SharedPtr<GS1CompositeBarExtendedParameters> second);

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


