#pragma once
// Copyright (c) 2001-2022 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <cstdint>

#include "BarCodeRecognition/Recognition/RecognitionSession/BarcodeResults/BaseExtendedParameters.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class BarCodeExtendedParameters;
class CodeResult;
} // namespace BarCodeRecognition
namespace Generation
{
enum class MaxiCodeMode;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS MaxiCodeExtendedParameters final : public Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters
{
    typedef MaxiCodeExtendedParameters ThisType;
    typedef Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::BarCodeExtendedParameters;
    friend ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<MaxiCodeExtendedParameters> first, System::SharedPtr<MaxiCodeExtendedParameters> second);
    friend ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<MaxiCodeExtendedParameters> first, System::SharedPtr<MaxiCodeExtendedParameters> second);
    
public:

    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::MaxiCodeMode get_MaxiCodeMode() const;
    ASPOSE_BARCODE_SHARED_API int32_t get_MaxiCodeStructuredAppendModeBarcodeId() const;
    ASPOSE_BARCODE_SHARED_API int32_t get_MaxiCodeStructuredAppendModeBarcodesCount() const;
    
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    ASPOSE_BARCODE_SHARED_API void set_MaxiCodeMode(Aspose::BarCode::Generation::MaxiCodeMode value);
    ASPOSE_BARCODE_SHARED_API void set_MaxiCodeStructuredAppendModeBarcodeId(int32_t value);
    ASPOSE_BARCODE_SHARED_API void set_MaxiCodeStructuredAppendModeBarcodesCount(int32_t value);
    
    MaxiCodeExtendedParameters(System::SharedPtr<CodeResult> aResult);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(MaxiCodeExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<CodeResult> aResult));
    
    MaxiCodeExtendedParameters(System::SharedPtr<MaxiCodeExtendedParameters> aParameters);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(MaxiCodeExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<MaxiCodeExtendedParameters> aParameters));
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    Aspose::BarCode::Generation::MaxiCodeMode _maxiCodeMode;
    int32_t _maxiCodeStructuredAppendModeBarcodeId;
    int32_t _maxiCodeStructuredAppendModeBarcodesCount;
    
    System::String ToString_NonConst();
    static bool IsEqual(System::SharedPtr<MaxiCodeExtendedParameters> first, System::SharedPtr<MaxiCodeExtendedParameters> second);
    
};

ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<MaxiCodeExtendedParameters> first, System::SharedPtr<MaxiCodeExtendedParameters> second);
ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<MaxiCodeExtendedParameters> first, System::SharedPtr<MaxiCodeExtendedParameters> second);

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


