#pragma once
// Copyright (c) 2001-2019 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <cstdint>

#include "BarCodeRecognition/Recognition/RecognitionSession/BarcodeResults/BaseExtendedParameters.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class BarCodeExtendedParameters;
class CodeResult;
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS OneDExtendedParameters final : public Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters
{
    typedef OneDExtendedParameters ThisType;
    typedef Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::BarCodeExtendedParameters;
    friend ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<OneDExtendedParameters> first, System::SharedPtr<OneDExtendedParameters> second);
    friend ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<OneDExtendedParameters> first, System::SharedPtr<OneDExtendedParameters> second);
    
public:

    ASPOSE_BARCODE_SHARED_API System::String get_Value() const;
    ASPOSE_BARCODE_SHARED_API System::String get_CheckSum() const;
    
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    OneDExtendedParameters(System::SharedPtr<CodeResult> aResult);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(OneDExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<CodeResult> aResult));
    
    OneDExtendedParameters(System::SharedPtr<OneDExtendedParameters> aParameters);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(OneDExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<OneDExtendedParameters> aParameters));
    
private:

    System::String _value;
    System::String _checkSum;
    
    System::String ToString_NonConst();
    static bool IsEqual(System::SharedPtr<OneDExtendedParameters> first, System::SharedPtr<OneDExtendedParameters> second);
    
};

ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<OneDExtendedParameters> first, System::SharedPtr<OneDExtendedParameters> second);
ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<OneDExtendedParameters> first, System::SharedPtr<OneDExtendedParameters> second);

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


