#pragma once
// Copyright (c) 2001-2024 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <system/date_time.h>
#include <cstdint>

#include "BarCodeRecognition/Recognition/RecognitionSession/BarcodeResults/BaseExtendedParameters.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class BarCodeExtendedParameters;
class CodeResult;
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS Pdf417ExtendedParameters final : public Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters
{
    typedef Pdf417ExtendedParameters ThisType;
    typedef Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::BarCodeExtendedParameters;
    friend ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<Pdf417ExtendedParameters> first, System::SharedPtr<Pdf417ExtendedParameters> second);
    friend ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<Pdf417ExtendedParameters> first, System::SharedPtr<Pdf417ExtendedParameters> second);
    
public:

    ASPOSE_BARCODE_SHARED_API System::String get_MacroPdf417FileID() const;
    ASPOSE_BARCODE_SHARED_API int32_t get_MacroPdf417SegmentID() const;
    ASPOSE_BARCODE_SHARED_API int32_t get_MacroPdf417SegmentsCount() const;
    ASPOSE_BARCODE_SHARED_API System::String get_MacroPdf417FileName() const;
    ASPOSE_BARCODE_SHARED_API int32_t get_MacroPdf417FileSize() const;
    ASPOSE_BARCODE_SHARED_API System::String get_MacroPdf417Sender() const;
    ASPOSE_BARCODE_SHARED_API System::String get_MacroPdf417Addressee() const;
    ASPOSE_BARCODE_SHARED_API System::DateTime get_MacroPdf417TimeStamp() const;
    ASPOSE_BARCODE_SHARED_API int32_t get_MacroPdf417Checksum() const;
    ASPOSE_BARCODE_SHARED_API bool get_MacroPdf417Terminator() const;
    ASPOSE_BARCODE_SHARED_API bool get_IsReaderInitialization() const;
    ASPOSE_BARCODE_SHARED_API bool get_IsLinked() const;
    ASPOSE_BARCODE_SHARED_API bool get_IsCode128Emulation() const;
    
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    Pdf417ExtendedParameters(System::SharedPtr<CodeResult> aResult);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Pdf417ExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<CodeResult> aResult));
    
    Pdf417ExtendedParameters(System::SharedPtr<Pdf417ExtendedParameters> aParameters);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Pdf417ExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<Pdf417ExtendedParameters> aParameters));
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::String _macroPdf417FileID;
    int32_t _macroPdf417SegmentID;
    int32_t _macroPdf417SegmentsCount;
    bool _isReaderInitialization;
    bool _isLinked;
    bool _isCode128Emulation;
    System::String pr_MacroPdf417FileName;
    
    ASPOSE_BARCODE_SHARED_API void set_MacroPdf417FileName(System::String value);
    
    int32_t pr_MacroPdf417FileSize;
    
    ASPOSE_BARCODE_SHARED_API void set_MacroPdf417FileSize(int32_t value);
    
    System::String pr_MacroPdf417Sender;
    
    ASPOSE_BARCODE_SHARED_API void set_MacroPdf417Sender(System::String value);
    
    System::String pr_MacroPdf417Addressee;
    
    ASPOSE_BARCODE_SHARED_API void set_MacroPdf417Addressee(System::String value);
    
    System::DateTime pr_MacroPdf417TimeStamp;
    
    ASPOSE_BARCODE_SHARED_API void set_MacroPdf417TimeStamp(System::DateTime value);
    
    int32_t pr_MacroPdf417Checksum;
    
    ASPOSE_BARCODE_SHARED_API void set_MacroPdf417Checksum(int32_t value);
    
    bool pr_MacroPdf417Terminator;
    
    ASPOSE_BARCODE_SHARED_API void set_MacroPdf417Terminator(bool value);
    
    System::String ToString_NonConst();
    static bool IsEqual(System::SharedPtr<Pdf417ExtendedParameters> first, System::SharedPtr<Pdf417ExtendedParameters> second);
    
};

ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<Pdf417ExtendedParameters> first, System::SharedPtr<Pdf417ExtendedParameters> second);
ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<Pdf417ExtendedParameters> first, System::SharedPtr<Pdf417ExtendedParameters> second);

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


