#pragma once
// Copyright (c) 2001-2019 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <cstdint>

#include "BarCodeRecognition/Recognition/RecognitionSession/BarcodeResults/BaseExtendedParameters.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class BarCodeExtendedParameters;
class CodeResult;
} // namespace BarCodeRecognition
namespace Generation
{
enum class MicroQRVersion;
enum class QRErrorLevel;
enum class QRVersion;
enum class RectMicroQRVersion;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS QRExtendedParameters final : public Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters
{
    typedef QRExtendedParameters ThisType;
    typedef Aspose::BarCode::BarCodeRecognition::BaseExtendedParameters BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::BarCodeExtendedParameters;
    friend ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<QRExtendedParameters> first, System::SharedPtr<QRExtendedParameters> second);
    friend ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<QRExtendedParameters> first, System::SharedPtr<QRExtendedParameters> second);
    
public:

    ASPOSE_BARCODE_SHARED_API int32_t get_QRStructuredAppendModeBarCodesQuantity() const;
    ASPOSE_BARCODE_SHARED_API int32_t get_QRStructuredAppendModeBarCodeIndex() const;
    ASPOSE_BARCODE_SHARED_API int32_t get_QRStructuredAppendModeParityData() const;
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::QRVersion get_QRVersion() const;
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::MicroQRVersion get_MicroQRVersion() const;
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::RectMicroQRVersion get_RectMicroQRVersion() const;
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::QRErrorLevel get_QRErrorLevel() const;
    
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    QRExtendedParameters(System::SharedPtr<CodeResult> aResult);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(QRExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<CodeResult> aResult));
    
    QRExtendedParameters(System::SharedPtr<QRExtendedParameters> aParameters);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(QRExtendedParameters, CODEPORTING_ARGS(System::SharedPtr<QRExtendedParameters> aParameters));
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    int32_t _qrStructuredAppendModeBarCodesQuantity;
    int32_t _qrStructuredAppendModeBarCodeIndex;
    int32_t _qrStructuredAppendModeParityData;
    Aspose::BarCode::Generation::QRVersion _qrVersion;
    Aspose::BarCode::Generation::MicroQRVersion _microQrVersion;
    Aspose::BarCode::Generation::RectMicroQRVersion _rectMicroQrVersion;
    Aspose::BarCode::Generation::QRErrorLevel _qrErrorLevel;
    
    System::String ToString_NonConst();
    static bool IsEqual(System::SharedPtr<QRExtendedParameters> first, System::SharedPtr<QRExtendedParameters> second);
    
};

ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<QRExtendedParameters> first, System::SharedPtr<QRExtendedParameters> second);
ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<QRExtendedParameters> first, System::SharedPtr<QRExtendedParameters> second);

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


