#pragma once
// Copyright (c) 2001-2019 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <system/iequatable.h>
#include <drawing/point.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace System
{
namespace Drawing
{
class Rectangle;
} // namespace Drawing
} // namespace System

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS Quadrangle : public System::IEquatable<System::SharedPtr<Aspose::BarCode::BarCodeRecognition::Quadrangle>>
{
    typedef Quadrangle ThisType;
    typedef System::IEquatable<System::SharedPtr<Aspose::BarCode::BarCodeRecognition::Quadrangle>> BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<Quadrangle> first, System::SharedPtr<Quadrangle> second);
    friend ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<Quadrangle> first, System::SharedPtr<Quadrangle> second);
    
public:

    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<Quadrangle> Empty;
    
    ASPOSE_BARCODE_SHARED_API System::Drawing::Point get_LeftTop() const;
    ASPOSE_BARCODE_SHARED_API void set_LeftTop(System::Drawing::Point value);
    ASPOSE_BARCODE_SHARED_API System::Drawing::Point get_RightTop() const;
    ASPOSE_BARCODE_SHARED_API void set_RightTop(System::Drawing::Point value);
    ASPOSE_BARCODE_SHARED_API System::Drawing::Point get_RightBottom() const;
    ASPOSE_BARCODE_SHARED_API void set_RightBottom(System::Drawing::Point value);
    ASPOSE_BARCODE_SHARED_API System::Drawing::Point get_LeftBottom() const;
    ASPOSE_BARCODE_SHARED_API void set_LeftBottom(System::Drawing::Point value);
    ASPOSE_BARCODE_SHARED_API bool get_IsEmpty();
    ASPOSE_BARCODE_SHARED_API System::Drawing::Rectangle get_BoundingRectangle();
    
    ASPOSE_BARCODE_SHARED_API Quadrangle();
    ASPOSE_BARCODE_SHARED_API Quadrangle(System::Drawing::Point leftTop, System::Drawing::Point rightTop, System::Drawing::Point rightBottom, System::Drawing::Point leftBottom);
    
    ASPOSE_BARCODE_SHARED_API bool Contains(System::Drawing::Point pt);
    ASPOSE_BARCODE_SHARED_API bool Contains(int32_t x, int32_t y);
    ASPOSE_BARCODE_SHARED_API bool Contains(System::SharedPtr<Quadrangle> quad);
    ASPOSE_BARCODE_SHARED_API bool Contains(System::Drawing::Rectangle rect);
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<Quadrangle> other) override;
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    virtual ASPOSE_BARCODE_SHARED_API ~Quadrangle();
    
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::Drawing::Point pr_LeftTop;
    System::Drawing::Point pr_RightTop;
    System::Drawing::Point pr_RightBottom;
    System::Drawing::Point pr_LeftBottom;
    
    System::String ToString_NonConst();
    static bool IsEqual(System::SharedPtr<Quadrangle> first, System::SharedPtr<Quadrangle> second);
    bool GetIsEmpty();
    System::Drawing::Rectangle GetBoundingRectangle();
    
};

ASPOSE_BARCODE_SHARED_API bool operator ==(System::SharedPtr<Quadrangle> first, System::SharedPtr<Quadrangle> second);
ASPOSE_BARCODE_SHARED_API bool operator !=(System::SharedPtr<Quadrangle> first, System::SharedPtr<Quadrangle> second);

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


