#pragma once
//Copyright(c) 2001-2021 Aspose Pty Ltd.All rights reserved.

#include <system/object.h>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class AustraliaPostCustomerInformationDecoder;
class BarcodeSettings;
class PostalRecFilter;
class PostalScanOptions;
} // namespace BarCodeRecognition
enum class CustomerInformationInterpretingType;
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS AustraliaPostSettings final : public System::Object
{
    typedef AustraliaPostSettings ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::PostalRecFilter;
    friend class Aspose::BarCode::BarCodeRecognition::PostalScanOptions;
    friend class Aspose::BarCode::BarCodeRecognition::BarcodeSettings;
    
public:

    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::CustomerInformationInterpretingType get_CustomerInformationInterpretingType() const;
    ASPOSE_BARCODE_SHARED_API void set_CustomerInformationInterpretingType(Aspose::BarCode::CustomerInformationInterpretingType value);
    ASPOSE_BARCODE_SHARED_API bool get_IgnoreEndingFillingPatternsForCTable() const;
    ASPOSE_BARCODE_SHARED_API void set_IgnoreEndingFillingPatternsForCTable(bool value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<AustraliaPostCustomerInformationDecoder> get_CustomerInformationDecoder() const;
    ASPOSE_BARCODE_SHARED_API void set_CustomerInformationDecoder(System::SharedPtr<AustraliaPostCustomerInformationDecoder> value);
    
protected:

    AustraliaPostSettings();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(AustraliaPostSettings, CODEPORTING_ARGS());
    
    AustraliaPostSettings(System::SharedPtr<AustraliaPostSettings> settings);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(AustraliaPostSettings, CODEPORTING_ARGS(System::SharedPtr<AustraliaPostSettings> settings));
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    Aspose::BarCode::CustomerInformationInterpretingType _customerInformationInterpretingType;
    bool _ignoreEndingFillingPatternsForCTable;
    System::SharedPtr<AustraliaPostCustomerInformationDecoder> _customerInformationDecoder;
    
};

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


