#pragma once
//Copyright(c) 2001-2021 Aspose Pty Ltd.All rights reserved.

#include <system/object.h>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class AustraliaPostSettings;
class BarCodeReaderImplementation;
enum class ChecksumValidation;
class RecognitionOptions;
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS BarcodeSettings final : public System::Object
{
    typedef BarcodeSettings ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::BarCodeReaderImplementation;
    friend class Aspose::BarCode::BarCodeRecognition::RecognitionOptions;
    
public:

    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::BarCodeRecognition::ChecksumValidation get_ChecksumValidation() const;
    ASPOSE_BARCODE_SHARED_API void set_ChecksumValidation(Aspose::BarCode::BarCodeRecognition::ChecksumValidation value);
    ASPOSE_BARCODE_SHARED_API bool get_StripFNC() const;
    ASPOSE_BARCODE_SHARED_API void set_StripFNC(bool value);
    ASPOSE_BARCODE_SHARED_API bool get_DetectEncoding() const;
    ASPOSE_BARCODE_SHARED_API void set_DetectEncoding(bool value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<AustraliaPostSettings> get_AustraliaPost() const;
    
protected:

    BarcodeSettings();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(BarcodeSettings, CODEPORTING_ARGS());
    
    BarcodeSettings(System::SharedPtr<BarcodeSettings> settings);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(BarcodeSettings, CODEPORTING_ARGS(System::SharedPtr<BarcodeSettings> settings));
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    Aspose::BarCode::BarCodeRecognition::ChecksumValidation _checksumValidation;
    bool _stripFNC;
    bool _detectEncoding;
    System::SharedPtr<AustraliaPostSettings> _australiaPost;
    
};

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


