#pragma once
//-----------------------------------------------------------------------------------------------------------
// <copyright file="BaseDecodeType.cs" company="Aspose Pty Ltd" author="Evgeniy Timofeev" date="18.02.2016 20:29:57">
//     Copyright (c) 2016-2024 Aspose Pty Ltd. All rights reserved.
// </copyright>
//-----------------------------------------------------------------------------------------------------------

#include <system/iequatable.h>
#include <system/array.h>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class MultyDecodeType;
class SingleDecodeType;
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS BaseDecodeType : public virtual System::IEquatable<System::SharedPtr<Aspose::BarCode::BarCodeRecognition::BaseDecodeType>>
{
    typedef BaseDecodeType ThisType;
    typedef System::IEquatable<System::SharedPtr<Aspose::BarCode::BarCodeRecognition::BaseDecodeType>> BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    virtual ASPOSE_BARCODE_SHARED_API bool ContainsAny(const System::ArrayPtr<System::SharedPtr<BaseDecodeType>>& types) = 0;
    virtual ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<SingleDecodeType> other);
    virtual ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<MultyDecodeType> other);
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<BaseDecodeType> other) override;
    static ASPOSE_BARCODE_SHARED_API bool TryParse(System::String parsingType, System::SharedPtr<SingleDecodeType>& result);
    static ASPOSE_BARCODE_SHARED_API bool TryParse(System::String parsingType, System::SharedPtr<MultyDecodeType>& result);
    static ASPOSE_BARCODE_SHARED_API bool TryParse(System::String parsingType, System::SharedPtr<BaseDecodeType>& result);
    
protected:

    BaseDecodeType();
    
    virtual ASPOSE_BARCODE_SHARED_API ~BaseDecodeType();
    
};

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


