#pragma once
//-----------------------------------------------------------------------------------------------------------
// <copyright file="DecodeType.cs" company="Aspose Pty Ltd" author="Evgeniy Timofeev" date="18.02.2016 20:29:57">
//     Copyright (c) 2016-2024 Aspose Pty Ltd. All rights reserved.
// </copyright>
//-----------------------------------------------------------------------------------------------------------

#include <system/array.h>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class AztecRecFilter;
class BaseDecodeType;
class DataMatrixExtFilter;
class DotCodeRecFilter;
class HanXinRecFilter;
class MaxiCodeRecFilter;
class MicrE13BRecFilter;
class MicroPDF417RecFilter;
class MultyDecodeType;
class Pdf417RecFilter;
class QRCodeRecFilter;
class SingleDecodeType;
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS DecodeType
{
    typedef DecodeType ThisType;
    
    friend class Aspose::BarCode::BarCodeRecognition::AztecRecFilter;
    friend class Aspose::BarCode::BarCodeRecognition::DataMatrixExtFilter;
    friend class Aspose::BarCode::BarCodeRecognition::DotCodeRecFilter;
    friend class Aspose::BarCode::BarCodeRecognition::HanXinRecFilter;
    friend class Aspose::BarCode::BarCodeRecognition::MaxiCodeRecFilter;
    friend class Aspose::BarCode::BarCodeRecognition::MicroPDF417RecFilter;
    friend class Aspose::BarCode::BarCodeRecognition::MicrE13BRecFilter;
    friend class Aspose::BarCode::BarCodeRecognition::Pdf417RecFilter;
    friend class Aspose::BarCode::BarCodeRecognition::QRCodeRecFilter;
    
public:

    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> None;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Codabar;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Code11;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Code39;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Code39FullASCII;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Code93;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Code128;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> GS1Code128;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> EAN8;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> EAN13;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> EAN14;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> SCC14;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> SSCC18;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> UPCA;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> UPCE;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> ISBN;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Standard2of5;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Interleaved2of5;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Matrix2of5;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> ItalianPost25;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> IATA2of5;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> ITF14;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> ITF6;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> MSI;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> VIN;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> DeutschePostIdentcode;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> DeutschePostLeitcode;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> OPC;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> PZN;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Pharmacode;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> DataMatrix;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> GS1DataMatrix;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> QR;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Aztec;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> GS1Aztec;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Pdf417;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> MacroPdf417;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> MicroPdf417;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> GS1MicroPdf417;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> CodablockF;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> AustraliaPost;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Postnet;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Planet;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> OneCode;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> RM4SCC;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Mailmark;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> DatabarOmniDirectional;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> DatabarTruncated;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> DatabarLimited;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> DatabarExpanded;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> DatabarStackedOmniDirectional;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> DatabarStacked;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> DatabarExpandedStacked;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> PatchCode;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> ISSN;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> ISMN;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Supplement;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> AustralianPosteParcel;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> SwissPostParcel;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Code16K;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> MicroQR;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> CompactPdf417;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> GS1QR;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> MaxiCode;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> MicrE13B;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Code32;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> DataLogic2of5;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> DotCode;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> GS1DotCode;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> DutchKIX;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> HIBCCode39LIC;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> HIBCCode128LIC;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> HIBCAztecLIC;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> HIBCDataMatrixLIC;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> HIBCQRLIC;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> HIBCCode39PAS;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> HIBCCode128PAS;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> HIBCAztecPAS;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> HIBCDataMatrixPAS;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> HIBCQRPAS;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> HanXin;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> GS1HanXin;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> GS1CompositeBar;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> RectMicroQR;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<MultyDecodeType> Types1D;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<MultyDecodeType> Types2D;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<MultyDecodeType> PostalTypes;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<MultyDecodeType> MostCommonTypes;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<MultyDecodeType> AllSupportedTypes;
    
    static ASPOSE_BARCODE_SHARED_API System::ArrayPtr<System::SharedPtr<SingleDecodeType>> get_AllSupportedTypesArray();
    
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<BaseDecodeType> ScanSets(const System::ArrayPtr<System::SharedPtr<BaseDecodeType>>& barcodeTypes);
    static ASPOSE_BARCODE_SHARED_API System::ArrayPtr<System::String> GetNames();
    static ASPOSE_BARCODE_SHARED_API bool Parse(System::String parsingType, System::SharedPtr<SingleDecodeType>& result);
    static ASPOSE_BARCODE_SHARED_API bool TryParse(System::String parsingType, System::SharedPtr<SingleDecodeType>& result);
    static ASPOSE_BARCODE_SHARED_API bool TryParse(System::String parsingType, System::SharedPtr<MultyDecodeType>& result);
    static ASPOSE_BARCODE_SHARED_API bool Is1D(System::SharedPtr<BaseDecodeType> symbology);
    static ASPOSE_BARCODE_SHARED_API bool IsPostal(System::SharedPtr<BaseDecodeType> symbology);
    static ASPOSE_BARCODE_SHARED_API bool Is2D(System::SharedPtr<BaseDecodeType> symbology);
    
protected:

    static bool IsMicrE13b(System::SharedPtr<BaseDecodeType> symbology);
    static bool IsAztec(System::SharedPtr<BaseDecodeType> symbology);
    static bool IsQR(System::SharedPtr<BaseDecodeType> symbology);
    static bool IsDatamatrix(System::SharedPtr<BaseDecodeType> symbology);
    static bool IsGS1Datamatrix(System::SharedPtr<BaseDecodeType> symbology);
    static bool IsPDF417(System::SharedPtr<BaseDecodeType> symbology);
    static bool IsCompactPdf417(System::SharedPtr<BaseDecodeType> symbology);
    static bool IsMicroPDF417(System::SharedPtr<BaseDecodeType> symbology);
    static bool IsMaxiCode(System::SharedPtr<BaseDecodeType> symbology);
    static bool IsDotCode(System::SharedPtr<BaseDecodeType> symbology);
    static bool IsHanXin(System::SharedPtr<BaseDecodeType> symbology);
    static bool AreEqual(System::SharedPtr<SingleDecodeType> type1, System::SharedPtr<SingleDecodeType> type2);
    static bool IsAllSupportedTypes(System::SharedPtr<BaseDecodeType> barcodeDataType);
    
private:

    static System::ArrayPtr<System::SharedPtr<SingleDecodeType>> s_allSupportedTypes;
    static System::ArrayPtr<System::SharedPtr<SingleDecodeType>> s_types1D;
    static System::ArrayPtr<System::SharedPtr<SingleDecodeType>> s_types2D;
    static System::ArrayPtr<System::SharedPtr<SingleDecodeType>> s_postalTypes;
    static System::ArrayPtr<System::SharedPtr<SingleDecodeType>> s_mostCommonTypes;
    
    static struct __StaticConstructor__ { __StaticConstructor__(); } s_constructor__;
    
public:
    DecodeType() = delete;
};

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


