#pragma once
//-----------------------------------------------------------------------------------------------------------
// <copyright file="MultyDecodeType.cs" company="Aspose Pty Ltd" author="Evgeniy Timofeev" date="18.02.2016 20:29:57">
//     Copyright (c) 2016 Aspose Pty Ltd. All rights reserved.
// </copyright>
//-----------------------------------------------------------------------------------------------------------

#include <system/iequatable.h>
#include <system/details/pointer_collection_helpers.h>
#include <cstdint>

#include "BarCodeRecognition/Recognition/RecognitionSession/DecodeTypes/BaseDecodeType.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class SingleDecodeType;
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose
namespace System
{
namespace Collections
{
namespace Generic
{
template <typename, typename> class Dictionary;
template <typename> class List;
} // namespace Generic
} // namespace Collections
} // namespace System

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS MultyDecodeType : public Aspose::BarCode::BarCodeRecognition::BaseDecodeType, public System::IEquatable<System::SharedPtr<Aspose::BarCode::BarCodeRecognition::MultyDecodeType>>
{
    typedef MultyDecodeType ThisType;
    typedef Aspose::BarCode::BarCodeRecognition::BaseDecodeType BaseType;
    typedef System::IEquatable<System::SharedPtr<Aspose::BarCode::BarCodeRecognition::MultyDecodeType>> BaseType1;
    
    typedef ::System::BaseTypesInfo<BaseType, BaseType1> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    ASPOSE_BARCODE_SHARED_API int32_t get_GetSingleTypesCount();
    
    ASPOSE_BARCODE_SHARED_API MultyDecodeType(const System::ArrayPtr<System::SharedPtr<SingleDecodeType>>& barcodeTypes);
    ASPOSE_BARCODE_SHARED_API MultyDecodeType(const System::ArrayPtr<System::SharedPtr<BaseDecodeType>>& barcodeTypes);
    
    ASPOSE_BARCODE_SHARED_API void Add(System::SharedPtr<SingleDecodeType> singleType);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<MultyDecodeType> Exclude(System::SharedPtr<SingleDecodeType> singleType);
    ASPOSE_BARCODE_SHARED_API bool ContainsAll(const System::ArrayPtr<System::SharedPtr<BaseDecodeType>>& barcodeTypes);
    static ASPOSE_BARCODE_SHARED_API bool TryParse(System::String parsingType, System::SharedPtr<MultyDecodeType>& result);
    ASPOSE_BARCODE_SHARED_API bool ContainsAny(const System::ArrayPtr<System::SharedPtr<BaseDecodeType>>& decodeTypes) override;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<System::Collections::Generic::List<System::SharedPtr<SingleDecodeType>>> GetSingleTypes();
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<MultyDecodeType> other) override;
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<SingleDecodeType> other) override;
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<System::Object> obj) override;
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    ASPOSE_BARCODE_SHARED_API void SetTemplateWeakPtr(uint32_t argument) override;
    
protected:

    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<System::Collections::Generic::Dictionary<int16_t, System::SharedPtr<SingleDecodeType>>> _typeSet;
    
    System::String ToString_NonConst();
    static System::ArrayPtr<System::SharedPtr<SingleDecodeType>> StraightMultyTypes(System::ArrayPtr<System::SharedPtr<BaseDecodeType>> barcodeTypes);
    
};

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


