#pragma once
//-----------------------------------------------------------------------------------------------------------
// <copyright file="SingleDecodeType.cs" company="Aspose Pty Ltd" author="Evgeniy Timofeev" date="18.02.2016 20:29:57">
//     Copyright (c) 2016-2024 Aspose Pty Ltd. All rights reserved.
// </copyright>
//-----------------------------------------------------------------------------------------------------------

#include <system/iequatable.h>
#include <system/details/pointer_collection_helpers.h>
#include <cstdint>

#include "BarCodeRecognition/Recognition/RecognitionSession/DecodeTypes/BaseDecodeType.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
class DecodeType;
class MultyDecodeType;
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS SingleDecodeType final : public Aspose::BarCode::BarCodeRecognition::BaseDecodeType, public System::IEquatable<System::SharedPtr<Aspose::BarCode::BarCodeRecognition::SingleDecodeType>>
{
    typedef SingleDecodeType ThisType;
    typedef Aspose::BarCode::BarCodeRecognition::BaseDecodeType BaseType;
    typedef System::IEquatable<System::SharedPtr<Aspose::BarCode::BarCodeRecognition::SingleDecodeType>> BaseType1;
    
    typedef ::System::BaseTypesInfo<BaseType, BaseType1> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::DecodeType;
    
public:

    ASPOSE_BARCODE_SHARED_API int16_t get_TypeIndex() const;
    ASPOSE_BARCODE_SHARED_API System::String get_TypeName() const;
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    ASPOSE_BARCODE_SHARED_API System::String GetString();
    static ASPOSE_BARCODE_SHARED_API System::String GetString(System::SharedPtr<SingleDecodeType> instance);
    ASPOSE_BARCODE_SHARED_API bool ContainsAny(const System::ArrayPtr<System::SharedPtr<BaseDecodeType>>& types) override;
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<SingleDecodeType> other) override;
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<MultyDecodeType> other) override;
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<System::Object> obj) override;
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SingleDecodeType> Parse(System::String stringDecodeType);
    ASPOSE_BARCODE_SHARED_API void SetTemplateWeakPtr(uint32_t argument) override;
    
protected:

    SingleDecodeType(int16_t typeIndex, System::String typeName);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(SingleDecodeType, CODEPORTING_ARGS(int16_t typeIndex, System::String typeName));
    
    virtual ASPOSE_BARCODE_SHARED_API ~SingleDecodeType();
    
private:

    int16_t _typeIndex;
    System::String _typeName;
    
    SingleDecodeType();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(SingleDecodeType, CODEPORTING_ARGS());
    
};

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


