#pragma once
//Copyright(c) 2001-2024 Aspose Pty Ltd.All rights reserved.

#include <system/object.h>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace BarCodeRecognition
{
enum class BarcodeQualityMode;
class BarCodeReaderImplementation;
enum class ComplexBackgroundMode;
enum class DeconvolutionMode;
enum class InverseImageMode;
class RecognitionOptions;
enum class XDimensionMode;
} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class ASPOSE_BARCODE_SHARED_CLASS QualitySettings final : public System::Object
{
    typedef QualitySettings ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::BarCodeRecognition::BarCodeReaderImplementation;
    friend class Aspose::BarCode::BarCodeRecognition::RecognitionOptions;
    
private:

    enum class PresetType
    {
        HighPerformance,
        NormalQuality,
        HighQuality,
        MaxQuality
    };
    
    
public:

    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<QualitySettings> get_HighPerformance();
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<QualitySettings> get_NormalQuality();
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<QualitySettings> get_HighQuality();
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<QualitySettings> get_MaxQuality();
    ASPOSE_BARCODE_SHARED_API XDimensionMode get_XDimension() const;
    ASPOSE_BARCODE_SHARED_API void set_XDimension(XDimensionMode value);
    ASPOSE_BARCODE_SHARED_API float get_MinimalXDimension() const;
    ASPOSE_BARCODE_SHARED_API void set_MinimalXDimension(float value);
    ASPOSE_BARCODE_SHARED_API BarcodeQualityMode get_BarcodeQuality() const;
    ASPOSE_BARCODE_SHARED_API void set_BarcodeQuality(BarcodeQualityMode value);
    ASPOSE_BARCODE_SHARED_API DeconvolutionMode get_Deconvolution() const;
    ASPOSE_BARCODE_SHARED_API void set_Deconvolution(DeconvolutionMode value);
    ASPOSE_BARCODE_SHARED_API InverseImageMode get_InverseImage() const;
    ASPOSE_BARCODE_SHARED_API void set_InverseImage(InverseImageMode value);
    ASPOSE_BARCODE_SHARED_API ComplexBackgroundMode get_ComplexBackground() const;
    ASPOSE_BARCODE_SHARED_API void set_ComplexBackground(ComplexBackgroundMode value);
    ASPOSE_BARCODE_SHARED_API bool get_AllowIncorrectBarcodes() const;
    ASPOSE_BARCODE_SHARED_API void set_AllowIncorrectBarcodes(bool value);
    
protected:

    static void ApplySetting(System::SharedPtr<QualitySettings> Src, System::SharedPtr<QualitySettings> Dst);
    
    QualitySettings();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(QualitySettings, CODEPORTING_ARGS());
    
    QualitySettings(System::SharedPtr<QualitySettings> Settings);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(QualitySettings, CODEPORTING_ARGS(System::SharedPtr<QualitySettings> Settings));
    void ApplyAll(System::SharedPtr<QualitySettings> Src);
    
    virtual ASPOSE_BARCODE_SHARED_API ~QualitySettings();
    
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    XDimensionMode pr_XDimension;
    float pr_MinimalXDimension;
    BarcodeQualityMode pr_BarcodeQuality;
    DeconvolutionMode pr_Deconvolution;
    InverseImageMode pr_InverseImage;
    ComplexBackgroundMode pr_ComplexBackground;
    bool pr_AllowIncorrectBarcodes;
    
    QualitySettings(QualitySettings::PresetType aType);
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(QualitySettings, CODEPORTING_ARGS(QualitySettings::PresetType aType));
    void InitHighPerformance();
    void InitNormalQuality();
    void InitHighQuality();
    void InitMaxQuality();
    
};

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


