#pragma once
// Copyright (c) 2001-2021 Aspose Pty Ltd. All Rights Reserved.

#include <cstdint>

#include "BarCodeRecognition/Recognition/RecognitionEngineException.h"
#include "aspose_barcode_api_defs.h"

namespace System
{
class String;
} // namespace System

namespace Aspose {

namespace BarCode {

namespace BarCodeRecognition {

class Details_RecognitionAbortedException;
using RecognitionAbortedException = System::ExceptionWrapper<Details_RecognitionAbortedException>;

class ASPOSE_BARCODE_SHARED_CLASS Details_RecognitionAbortedException : public Aspose::BarCode::BarCodeRecognition::Details_BarCodeRecognitionException
{
    typedef Details_RecognitionAbortedException ThisType;
    typedef Aspose::BarCode::BarCodeRecognition::Details_BarCodeRecognitionException BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class System::ExceptionWrapperHelper;
    template <typename T> friend class System::ExceptionWrapper;
    
public:

    ASPOSE_BARCODE_SHARED_API int32_t get_ExecutionTime() const;
    ASPOSE_BARCODE_SHARED_API void set_ExecutionTime(int32_t value);
    
protected:

    [[noreturn]] void DoThrow(const System::ExceptionPtr& self) const override;
    
    ASPOSE_BARCODE_SHARED_API Details_RecognitionAbortedException();
    
    ASPOSE_BARCODE_SHARED_API MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Details_RecognitionAbortedException, CODEPORTING_ARGS());
    
    ASPOSE_BARCODE_SHARED_API Details_RecognitionAbortedException(int32_t executionTime);
    
    ASPOSE_BARCODE_SHARED_API MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Details_RecognitionAbortedException, CODEPORTING_ARGS(int32_t executionTime));
    
    ASPOSE_BARCODE_SHARED_API Details_RecognitionAbortedException(System::String message, int32_t executionTime);
    
    ASPOSE_BARCODE_SHARED_API MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(Details_RecognitionAbortedException, CODEPORTING_ARGS(System::String message, int32_t executionTime));
    
private:

    int32_t _executionTime;
    
};

} // namespace BarCodeRecognition
} // namespace BarCode
} // namespace Aspose


