#pragma once
// Copyright (c) 2001-2022 Aspose Pty Ltd. All Rights Reserved.

#include <system/shared_ptr.h>
#include <system/idisposable.h>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace ComplexBarcode
{
class IComplexCodetext;
enum class Mailmark2DType;
} // namespace ComplexBarcode
namespace Generation
{
class BarcodeGenerator;
enum class BarCodeImageFormat;
class BaseGenerationParameters;
enum class ECIEncodings;
enum class MaxiCodeEncodeMode;
enum class MaxiCodeMode;
} // namespace Generation
class VentureLicenser;
} // namespace BarCode
} // namespace Aspose
namespace System
{
namespace Drawing
{
class Bitmap;
} // namespace Drawing
namespace IO
{
class Stream;
} // namespace IO
class String;
} // namespace System

namespace Aspose {

namespace BarCode {

namespace ComplexBarcode {

class ASPOSE_BARCODE_SHARED_CLASS ComplexBarcodeGenerator final : public System::IDisposable
{
    typedef ComplexBarcodeGenerator ThisType;
    typedef System::IDisposable BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::VentureLicenser;
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Aspose::BarCode::Generation::BaseGenerationParameters> get_Parameters();
    
    ASPOSE_BARCODE_SHARED_API ComplexBarcodeGenerator(System::SharedPtr<IComplexCodetext> complexCodetext);
    
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<System::Drawing::Bitmap> GenerateBarCodeImage();
    ASPOSE_BARCODE_SHARED_API void Save(System::SharedPtr<System::IO::Stream> stream, Aspose::BarCode::Generation::BarCodeImageFormat format);
    ASPOSE_BARCODE_SHARED_API void Save(System::String filename, Aspose::BarCode::Generation::BarCodeImageFormat format);
    ASPOSE_BARCODE_SHARED_API void Save(System::String filename);
    ASPOSE_BARCODE_SHARED_API void Dispose() override;
    
protected:

    void SetVentureLicense(System::SharedPtr<System::Object> ventureLicense);
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<Aspose::BarCode::Generation::BarcodeGenerator> _generator;
    
    void DisposeAllResources();
    void initSwissQrParams(System::String constructedText);
    void initMailmark2DParams(System::String constructedText, Mailmark2DType mailmark2D_Type);
    void initMaxiCodeParams(Aspose::BarCode::Generation::MaxiCodeMode maxiCodeMode, Aspose::BarCode::Generation::MaxiCodeEncodeMode maxiCodeEncodeMode, Aspose::BarCode::Generation::ECIEncodings ECIEncoding);
    
};

} // namespace ComplexBarcode
} // namespace BarCode
} // namespace Aspose


