#pragma once

#include <system/object.h>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace ComplexBarcode
{
class HIBCLICComplexCodetext;
class HIBCPASCodetext;
class Mailmark2DCodetext;
class MailmarkCodetext;
class MaxiCodeCodetext;
class SwissQRCodetext;
} // namespace ComplexBarcode
namespace Generation
{
enum class MaxiCodeMode;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose
namespace System
{
class String;
} // namespace System

namespace Aspose {

namespace BarCode {

namespace ComplexBarcode {

//public enum ComplexCodetextType { Unknown = -1, SwissQR = 0, USADriveId = 1 };
class ASPOSE_BARCODE_SHARED_CLASS ComplexCodetextReader final : public System::Object
{
    typedef ComplexCodetextReader ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<SwissQRCodetext> TryDecodeSwissQR(System::String encodedCodetext);
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<Mailmark2DCodetext> TryDecodeMailmark2D(System::String encodedCodetext);
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<MailmarkCodetext> TryDecodeMailmark(System::String encodedCodetext);
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<MaxiCodeCodetext> TryDecodeMaxiCode(Aspose::BarCode::Generation::MaxiCodeMode maxiCodeMode, System::String encodedCodetext);
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<HIBCLICComplexCodetext> TryDecodeHIBCLIC(System::String encodedCodetext);
    static ASPOSE_BARCODE_SHARED_API System::SharedPtr<HIBCPASCodetext> TryDecodeHIBCPAS(System::String encodedCodetext);
    
private:

    ComplexCodetextReader();
    
    MEMBER_FUNCTION_MAKE_OBJECT_DECLARATION(ComplexCodetextReader, CODEPORTING_ARGS());
    
};

} // namespace ComplexBarcode
} // namespace BarCode
} // namespace Aspose


