#pragma once

#include <system/object_ext.h>
#include <system/enum.h>
#include <system/date_time.h>
#include <system/array.h>
#include <cstdint>

#include "ComplexBarcode/ComplexCodetext/IComplexCodetext.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace ComplexBarcode
{
class ComplexCodetextReader;
class PrimaryData;
class SecondaryAndAdditionalData;
} // namespace ComplexBarcode
namespace Generation
{
class BaseEncodeType;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace ComplexBarcode {

enum class HIBCLICDateFormat
{
    YYYYMMDD = 0,
    MMYY = 1,
    MMDDYY = 2,
    YYMMDD = 3,
    YYMMDDHH = 4,
    YYJJJ = 5,
    YYJJJHH = 6,
    None = 7
};

class ASPOSE_BARCODE_SHARED_CLASS HIBCLICComplexCodetext : public Aspose::BarCode::ComplexBarcode::IComplexCodetext
{
    typedef HIBCLICComplexCodetext ThisType;
    typedef Aspose::BarCode::ComplexBarcode::IComplexCodetext BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::ComplexBarcode::ComplexCodetextReader;
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Aspose::BarCode::Generation::BaseEncodeType> get_BarcodeType() const;
    ASPOSE_BARCODE_SHARED_API void set_BarcodeType(System::SharedPtr<Aspose::BarCode::Generation::BaseEncodeType> value);
    
    ASPOSE_BARCODE_SHARED_API System::String GetConstructedCodetext() override = 0;
    ASPOSE_BARCODE_SHARED_API void InitFromString(System::String constructedCodetext) override = 0;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Aspose::BarCode::Generation::BaseEncodeType> GetBarcodeType() override;
    
    ASPOSE_BARCODE_SHARED_API HIBCLICComplexCodetext();
    
protected:

    static System::SharedPtr<HIBCLICComplexCodetext> SelectInstance(System::String encodedCodetext);
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<Aspose::BarCode::Generation::BaseEncodeType> _encodeType;
    
};

class ASPOSE_BARCODE_SHARED_CLASS HIBCLICCombinedCodetext : public Aspose::BarCode::ComplexBarcode::HIBCLICComplexCodetext
{
    typedef HIBCLICCombinedCodetext ThisType;
    typedef Aspose::BarCode::ComplexBarcode::HIBCLICComplexCodetext BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Aspose::BarCode::ComplexBarcode::PrimaryData> get_PrimaryData() const;
    ASPOSE_BARCODE_SHARED_API void set_PrimaryData(System::SharedPtr<Aspose::BarCode::ComplexBarcode::PrimaryData> value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Aspose::BarCode::ComplexBarcode::SecondaryAndAdditionalData> get_SecondaryAndAdditionalData() const;
    ASPOSE_BARCODE_SHARED_API void set_SecondaryAndAdditionalData(System::SharedPtr<Aspose::BarCode::ComplexBarcode::SecondaryAndAdditionalData> value);
    
    ASPOSE_BARCODE_SHARED_API System::String GetConstructedCodetext() override;
    ASPOSE_BARCODE_SHARED_API void InitFromString(System::String constructedCodetext) override;
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<System::Object> obj) override;
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    
protected:

    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<Aspose::BarCode::ComplexBarcode::PrimaryData> pr_PrimaryData;
    System::SharedPtr<Aspose::BarCode::ComplexBarcode::SecondaryAndAdditionalData> pr_SecondaryAndAdditionalData;
    
};

class ASPOSE_BARCODE_SHARED_CLASS HIBCLICPrimaryDataCodetext : public Aspose::BarCode::ComplexBarcode::HIBCLICComplexCodetext
{
    typedef HIBCLICPrimaryDataCodetext ThisType;
    typedef Aspose::BarCode::ComplexBarcode::HIBCLICComplexCodetext BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<PrimaryData> get_Data() const;
    ASPOSE_BARCODE_SHARED_API void set_Data(System::SharedPtr<PrimaryData> value);
    
    ASPOSE_BARCODE_SHARED_API System::String GetConstructedCodetext() override;
    ASPOSE_BARCODE_SHARED_API void InitFromString(System::String constructedCodetext) override;
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<System::Object> obj) override;
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    
    ASPOSE_BARCODE_SHARED_API HIBCLICPrimaryDataCodetext();
    
protected:

    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<PrimaryData> data;
    
};

class ASPOSE_BARCODE_SHARED_CLASS HIBCLICSecondaryAndAdditionalDataCodetext : public Aspose::BarCode::ComplexBarcode::HIBCLICComplexCodetext
{
    typedef HIBCLICSecondaryAndAdditionalDataCodetext ThisType;
    typedef Aspose::BarCode::ComplexBarcode::HIBCLICComplexCodetext BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<SecondaryAndAdditionalData> get_Data() const;
    ASPOSE_BARCODE_SHARED_API void set_Data(System::SharedPtr<SecondaryAndAdditionalData> value);
    ASPOSE_BARCODE_SHARED_API char16_t get_LinkCharacter() const;
    ASPOSE_BARCODE_SHARED_API void set_LinkCharacter(char16_t value);
    
    ASPOSE_BARCODE_SHARED_API System::String GetConstructedCodetext() override;
    ASPOSE_BARCODE_SHARED_API void InitFromString(System::String constructedCodetext) override;
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<System::Object> obj) override;
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    
    ASPOSE_BARCODE_SHARED_API HIBCLICSecondaryAndAdditionalDataCodetext();
    
protected:

    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<SecondaryAndAdditionalData> data;
    char16_t linkCharacter;
    
};

class ASPOSE_BARCODE_SHARED_CLASS SecondaryAndAdditionalData : public System::Object
{
    typedef SecondaryAndAdditionalData ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    ASPOSE_BARCODE_SHARED_API HIBCLICDateFormat get_ExpiryDateFormat() const;
    ASPOSE_BARCODE_SHARED_API void set_ExpiryDateFormat(HIBCLICDateFormat value);
    ASPOSE_BARCODE_SHARED_API System::DateTime get_ExpiryDate() const;
    ASPOSE_BARCODE_SHARED_API void set_ExpiryDate(System::DateTime value);
    ASPOSE_BARCODE_SHARED_API System::String get_LotNumber() const;
    ASPOSE_BARCODE_SHARED_API void set_LotNumber(System::String value);
    ASPOSE_BARCODE_SHARED_API System::String get_SerialNumber() const;
    ASPOSE_BARCODE_SHARED_API void set_SerialNumber(System::String value);
    ASPOSE_BARCODE_SHARED_API System::DateTime get_DateOfManufacture() const;
    ASPOSE_BARCODE_SHARED_API void set_DateOfManufacture(System::DateTime value);
    ASPOSE_BARCODE_SHARED_API int32_t get_Quantity() const;
    ASPOSE_BARCODE_SHARED_API void set_Quantity(int32_t value);
    
    ASPOSE_BARCODE_SHARED_API void ParseFromString(System::String secondaryDataCodetext);
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<System::Object> obj) override;
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    
    ASPOSE_BARCODE_SHARED_API SecondaryAndAdditionalData();
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
protected:

    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    HIBCLICDateFormat pr_ExpiryDateFormat;
    System::DateTime pr_ExpiryDate;
    System::String _lotNumber;
    System::String _serialNumber;
    System::DateTime pr_DateOfManufacture;
    int32_t _quantity;
    
    System::String ToString_NonConst();
    System::String GetFormatedExpiryDate();
    void ParseSecondaryData(System::String secondaryDataCodetext);
    void ParseAdditionalData(System::ArrayPtr<System::String> splittedCodetext);
    HIBCLICDateFormat GetDateFormat(System::String constructedCodetext, int32_t startPosition);
    System::DateTime ParseDate(System::String text, int32_t startPosition, HIBCLICDateFormat dateFormat);
    
};

class ASPOSE_BARCODE_SHARED_CLASS PrimaryData : public System::Object
{
    typedef PrimaryData ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    ASPOSE_BARCODE_SHARED_API System::String get_LabelerIdentificationCode() const;
    ASPOSE_BARCODE_SHARED_API void set_LabelerIdentificationCode(System::String value);
    ASPOSE_BARCODE_SHARED_API System::String get_ProductOrCatalogNumber() const;
    ASPOSE_BARCODE_SHARED_API void set_ProductOrCatalogNumber(System::String value);
    ASPOSE_BARCODE_SHARED_API int32_t get_UnitOfMeasureID() const;
    ASPOSE_BARCODE_SHARED_API void set_UnitOfMeasureID(int32_t value);
    
    ASPOSE_BARCODE_SHARED_API void ParseFromString(System::String primaryDataCodetext);
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<System::Object> obj) override;
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    
    ASPOSE_BARCODE_SHARED_API PrimaryData();
    
    ASPOSE_BARCODE_SHARED_API System::String ToString() const override;
    
private:

    System::String _labelerIdentificationCode;
    System::String _productOrCatalogNumber;
    int32_t _unitOfMeasureID;
    
    System::String ToString_NonConst();
    
};

} // namespace ComplexBarcode
} // namespace BarCode
} // namespace Aspose

template<>
struct EnumMetaInfo<Aspose::BarCode::ComplexBarcode::HIBCLICDateFormat>
{
    static const ASPOSE_BARCODE_SHARED_API std::array<std::pair<Aspose::BarCode::ComplexBarcode::HIBCLICDateFormat, const char_t*>, 8>& values();
};



