#pragma once

#include <system/object_ext.h>
#include <system/enum.h>
#include <cstdint>

#include "ComplexBarcode/ComplexCodetext/IComplexCodetext.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace ComplexBarcode
{
class HIBCPASRecord;
} // namespace ComplexBarcode
namespace Generation
{
class BaseEncodeType;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose
namespace System
{
namespace Collections
{
namespace Generic
{
template <typename> class List;
} // namespace Generic
} // namespace Collections
} // namespace System

namespace Aspose {

namespace BarCode {

namespace ComplexBarcode {

enum class HIBCPASDataLocation
{
    Patient = 0,
    PatientCareRecord = 1,
    SpecimenContainer = 2,
    DirectPatientImageItem = 3,
    BusinessRecord = 4,
    MedicalAdministrationRecord = 5,
    LibraryReferenceMaterial = 6,
    DevicesAndMaterials = 7,
    IdentificationCard = 8,
    ProductContainer = 9,
    Asset = 10,
    SurgicalInstrument = 11,
    UserDefined = 25
};

enum class HIBCPASDataType
{
    LabelerIdentificationCode = 0,
    ServiceIdentification = 1,
    PatientIdentification = 2,
    SpecimenIdentification = 3,
    PersonnelIdentification = 4,
    AdministrableProductIdentification = 5,
    ImplantableProductInformation = 6,
    HospitalItemIdentification = 7,
    MedicalProcedureIdentification = 8,
    ReimbursementCategory = 9,
    BloodProductIdentification = 10,
    DemographicData = 11,
    DateTime = 12,
    AssetIdentification = 13,
    PurchaseOrderNumber = 14,
    DietaryItemIdentification = 15,
    ManufacturerSerialNumber = 16,
    LibraryMaterialsIdentification = 17,
    BusinessControlNumber = 18,
    EpisodeOfCareIdentification = 19,
    HealthIndustryNumber = 20,
    PatientVisitID = 21,
    XMLDocument = 22,
    UserDefined = 25
};

class ASPOSE_BARCODE_SHARED_CLASS HIBCPASCodetext : public Aspose::BarCode::ComplexBarcode::IComplexCodetext
{
    typedef HIBCPASCodetext ThisType;
    typedef Aspose::BarCode::ComplexBarcode::IComplexCodetext BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Aspose::BarCode::Generation::BaseEncodeType> get_BarcodeType() const;
    ASPOSE_BARCODE_SHARED_API void set_BarcodeType(System::SharedPtr<Aspose::BarCode::Generation::BaseEncodeType> value);
    ASPOSE_BARCODE_SHARED_API HIBCPASDataLocation get_DataLocation() const;
    ASPOSE_BARCODE_SHARED_API void set_DataLocation(HIBCPASDataLocation value);
    
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<System::Collections::Generic::List<System::SharedPtr<HIBCPASRecord>>> GetRecords();
    ASPOSE_BARCODE_SHARED_API void AddRecord(HIBCPASDataType dataType, System::String data);
    ASPOSE_BARCODE_SHARED_API void AddRecord(System::SharedPtr<HIBCPASRecord> record);
    ASPOSE_BARCODE_SHARED_API void Clear();
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Aspose::BarCode::Generation::BaseEncodeType> GetBarcodeType() override;
    ASPOSE_BARCODE_SHARED_API System::String GetConstructedCodetext() override;
    ASPOSE_BARCODE_SHARED_API void InitFromString(System::String constructedCodetext) override;
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<System::Object> obj) override;
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    
    ASPOSE_BARCODE_SHARED_API HIBCPASCodetext();
    
protected:

    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<Aspose::BarCode::Generation::BaseEncodeType> _encodeType;
    HIBCPASDataLocation pr_DataLocation;
    System::SharedPtr<System::Collections::Generic::List<System::SharedPtr<HIBCPASRecord>>> _recordsList;
    
};

class ASPOSE_BARCODE_SHARED_CLASS HIBCPASRecord : public System::Object
{
    typedef HIBCPASRecord ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    ASPOSE_BARCODE_SHARED_API HIBCPASDataType get_DataType() const;
    ASPOSE_BARCODE_SHARED_API void set_DataType(HIBCPASDataType value);
    ASPOSE_BARCODE_SHARED_API System::String get_Data() const;
    ASPOSE_BARCODE_SHARED_API void set_Data(System::String value);
    
    ASPOSE_BARCODE_SHARED_API HIBCPASRecord(HIBCPASDataType dataType, System::String data);
    ASPOSE_BARCODE_SHARED_API HIBCPASRecord();
    
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<System::Object> obj) override;
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    
protected:

    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    HIBCPASDataType pr_DataType;
    System::String pr_Data;
    
};

} // namespace ComplexBarcode
} // namespace BarCode
} // namespace Aspose

template<>
struct EnumMetaInfo<Aspose::BarCode::ComplexBarcode::HIBCPASDataLocation>
{
    static const ASPOSE_BARCODE_SHARED_API std::array<std::pair<Aspose::BarCode::ComplexBarcode::HIBCPASDataLocation, const char_t*>, 13>& values();
};
template<>
struct EnumMetaInfo<Aspose::BarCode::ComplexBarcode::HIBCPASDataType>
{
    static const ASPOSE_BARCODE_SHARED_API std::array<std::pair<Aspose::BarCode::ComplexBarcode::HIBCPASDataType, const char_t*>, 24>& values();
};



