#pragma once

#include <system/object_ext.h>
#include <system/enum.h>
#include <cstdint>

#include "ComplexBarcode/ComplexCodetext/IComplexCodetext.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace ComplexBarcode
{
class ComplexBarcodeGenerator;
} // namespace ComplexBarcode
namespace Generation
{
class BaseEncodeType;
enum class DataMatrixEncodeMode;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace ComplexBarcode {

enum class Mailmark2DType
{
    Auto,
    Type_7,
    Type_9,
    Type_29
};

class ASPOSE_BARCODE_SHARED_CLASS Mailmark2DCodetext final : public Aspose::BarCode::ComplexBarcode::IComplexCodetext
{
    typedef Mailmark2DCodetext ThisType;
    typedef Aspose::BarCode::ComplexBarcode::IComplexCodetext BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::ComplexBarcode::ComplexBarcodeGenerator;
    
public:

    ASPOSE_BARCODE_SHARED_API System::String get_UPUCountryID() const;
    ASPOSE_BARCODE_SHARED_API void set_UPUCountryID(System::String value);
    ASPOSE_BARCODE_SHARED_API System::String get_InformationTypeID() const;
    ASPOSE_BARCODE_SHARED_API void set_InformationTypeID(System::String value);
    ASPOSE_BARCODE_SHARED_API System::String get_VersionID() const;
    ASPOSE_BARCODE_SHARED_API void set_VersionID(System::String value);
    ASPOSE_BARCODE_SHARED_API System::String get_Class() const;
    ASPOSE_BARCODE_SHARED_API void set_Class(System::String value);
    ASPOSE_BARCODE_SHARED_API int32_t get_SupplyChainID() const;
    ASPOSE_BARCODE_SHARED_API void set_SupplyChainID(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_ItemID() const;
    ASPOSE_BARCODE_SHARED_API void set_ItemID(int32_t value);
    ASPOSE_BARCODE_SHARED_API System::String get_DestinationPostCodeAndDPS() const;
    ASPOSE_BARCODE_SHARED_API void set_DestinationPostCodeAndDPS(System::String value);
    ASPOSE_BARCODE_SHARED_API System::String get_RTSFlag() const;
    ASPOSE_BARCODE_SHARED_API void set_RTSFlag(System::String value);
    ASPOSE_BARCODE_SHARED_API System::String get_ReturnToSenderPostCode() const;
    ASPOSE_BARCODE_SHARED_API void set_ReturnToSenderPostCode(System::String value);
    ASPOSE_BARCODE_SHARED_API System::String get_CustomerContent() const;
    ASPOSE_BARCODE_SHARED_API void set_CustomerContent(System::String value);
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::DataMatrixEncodeMode get_CustomerContentEncodeMode() const;
    ASPOSE_BARCODE_SHARED_API void set_CustomerContentEncodeMode(Aspose::BarCode::Generation::DataMatrixEncodeMode value);
    ASPOSE_BARCODE_SHARED_API Mailmark2DType get_DataMatrixType() const;
    ASPOSE_BARCODE_SHARED_API void set_DataMatrixType(Mailmark2DType value);
    
    ASPOSE_BARCODE_SHARED_API Mailmark2DCodetext();
    
    ASPOSE_BARCODE_SHARED_API System::String GetConstructedCodetext() override;
    ASPOSE_BARCODE_SHARED_API void InitFromString(System::String constructedCodetext) override;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Aspose::BarCode::Generation::BaseEncodeType> GetBarcodeType() override;
    
protected:

    Mailmark2DType get_DataMatrixTypeInternal() const;
    void set_DataMatrixTypeInternal(Mailmark2DType value);
    
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::String pr_UPUCountryID;
    System::String pr_InformationTypeID;
    System::String pr_VersionID;
    System::String pr_Class;
    int32_t pr_SupplyChainID;
    int32_t pr_ItemID;
    System::String pr_DestinationPostCodeAndDPS;
    System::String pr_RTSFlag;
    System::String pr_ReturnToSenderPostCode;
    System::String pr_CustomerContent;
    Aspose::BarCode::Generation::DataMatrixEncodeMode pr_CustomerContentEncodeMode;
    Mailmark2DType pr_DataMatrixType;
    Mailmark2DType pr_DataMatrixTypeInternal;
    
    void validate();
    void validateStringLength(System::String val, int32_t length);
    void validateInt(int32_t val, int32_t minVal, int32_t maxVal);
    
};

} // namespace ComplexBarcode
} // namespace BarCode
} // namespace Aspose

template<>
struct EnumMetaInfo<Aspose::BarCode::ComplexBarcode::Mailmark2DType>
{
    static const ASPOSE_BARCODE_SHARED_API std::array<std::pair<Aspose::BarCode::ComplexBarcode::Mailmark2DType, const char_t*>, 4>& values();
};



