#pragma once

#include <system/object_ext.h>
#include <system/enum.h>
#include <cstdint>

#include "ComplexBarcode/ComplexCodetext/IComplexCodetext.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace Generation
{
class BaseEncodeType;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace ComplexBarcode {

enum class Mailmark1DType
{
    Type_C,
    Type_L
};

class ASPOSE_BARCODE_SHARED_CLASS MailmarkCodetext final : public Aspose::BarCode::ComplexBarcode::IComplexCodetext
{
    typedef MailmarkCodetext ThisType;
    typedef Aspose::BarCode::ComplexBarcode::IComplexCodetext BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    ASPOSE_BARCODE_SHARED_API int32_t get_Format() const;
    ASPOSE_BARCODE_SHARED_API void set_Format(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_VersionID() const;
    ASPOSE_BARCODE_SHARED_API void set_VersionID(int32_t value);
    ASPOSE_BARCODE_SHARED_API System::String get_Class() const;
    ASPOSE_BARCODE_SHARED_API void set_Class(System::String value);
    ASPOSE_BARCODE_SHARED_API int32_t get_SupplychainID() const;
    ASPOSE_BARCODE_SHARED_API void set_SupplychainID(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_ItemID() const;
    ASPOSE_BARCODE_SHARED_API void set_ItemID(int32_t value);
    ASPOSE_BARCODE_SHARED_API System::String get_DestinationPostCodePlusDPS() const;
    ASPOSE_BARCODE_SHARED_API void set_DestinationPostCodePlusDPS(System::String value);
    
    ASPOSE_BARCODE_SHARED_API MailmarkCodetext();
    
    ASPOSE_BARCODE_SHARED_API System::String GetConstructedCodetext() override;
    ASPOSE_BARCODE_SHARED_API void InitFromString(System::String constructedCodetext) override;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Aspose::BarCode::Generation::BaseEncodeType> GetBarcodeType() override;
    
protected:

    Mailmark1DType get_Type() const;
    void set_Type(Mailmark1DType value);
    
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    Mailmark1DType pr_Type;
    int32_t pr_Format;
    int32_t pr_VersionID;
    System::String pr_Class;
    int32_t pr_SupplychainID;
    int32_t pr_ItemID;
    System::String pr_DestinationPostCodePlusDPS;
    
    void validate();
    void validateStringLength(System::String val, int32_t minLength, int32_t maxLength);
    void validateInt(int32_t val, int32_t minVal, int32_t maxVal);
    
};

} // namespace ComplexBarcode
} // namespace BarCode
} // namespace Aspose

template<>
struct EnumMetaInfo<Aspose::BarCode::ComplexBarcode::Mailmark1DType>
{
    static const ASPOSE_BARCODE_SHARED_API std::array<std::pair<Aspose::BarCode::ComplexBarcode::Mailmark1DType, const char_t*>, 2>& values();
};



