#pragma once
//Copyright(c) 2001-2022 Aspose Pty Ltd.All rights reserved.

#include <system/string.h>
#include <cstdint>

#include "ComplexBarcode/ComplexCodetext/IComplexCodetext.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace ComplexBarcode
{
class MaxiCodeSecondMessage;
} // namespace ComplexBarcode
namespace Generation
{
class BaseEncodeType;
enum class ECIEncodings;
enum class MaxiCodeEncodeMode;
enum class MaxiCodeMode;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose
namespace System
{
namespace Collections
{
namespace Generic
{
template <typename> class List;
} // namespace Generic
} // namespace Collections
} // namespace System

namespace Aspose {

namespace BarCode {

namespace ComplexBarcode {

class ASPOSE_BARCODE_SHARED_CLASS MaxiCodeCodetext : public Aspose::BarCode::ComplexBarcode::IComplexCodetext
{
    typedef MaxiCodeCodetext ThisType;
    typedef Aspose::BarCode::ComplexBarcode::IComplexCodetext BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::MaxiCodeEncodeMode get_MaxiCodeEncodeMode() const;
    ASPOSE_BARCODE_SHARED_API void set_MaxiCodeEncodeMode(Aspose::BarCode::Generation::MaxiCodeEncodeMode value);
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::ECIEncodings get_ECIEncoding() const;
    ASPOSE_BARCODE_SHARED_API void set_ECIEncoding(Aspose::BarCode::Generation::ECIEncodings value);
    
    virtual ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::MaxiCodeMode GetMode() const = 0;
    ASPOSE_BARCODE_SHARED_API System::String GetConstructedCodetext() override = 0;
    ASPOSE_BARCODE_SHARED_API void InitFromString(System::String constructedCodetext) override = 0;
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<Aspose::BarCode::Generation::BaseEncodeType> GetBarcodeType() override;
    
    ASPOSE_BARCODE_SHARED_API MaxiCodeCodetext();
    
protected:

    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    Aspose::BarCode::Generation::ECIEncodings eciEncoding;
    Aspose::BarCode::Generation::MaxiCodeEncodeMode pr_MaxiCodeEncodeMode;
    
};

class ASPOSE_BARCODE_SHARED_CLASS MaxiCodeStructuredCodetext : public Aspose::BarCode::ComplexBarcode::MaxiCodeCodetext
{
    typedef MaxiCodeStructuredCodetext ThisType;
    typedef Aspose::BarCode::ComplexBarcode::MaxiCodeCodetext BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    ASPOSE_BARCODE_SHARED_API System::String get_PostalCode() const;
    ASPOSE_BARCODE_SHARED_API void set_PostalCode(System::String value);
    ASPOSE_BARCODE_SHARED_API int32_t get_CountryCode() const;
    ASPOSE_BARCODE_SHARED_API void set_CountryCode(int32_t value);
    ASPOSE_BARCODE_SHARED_API int32_t get_ServiceCategory() const;
    ASPOSE_BARCODE_SHARED_API void set_ServiceCategory(int32_t value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<MaxiCodeSecondMessage> get_SecondMessage() const;
    ASPOSE_BARCODE_SHARED_API void set_SecondMessage(System::SharedPtr<MaxiCodeSecondMessage> value);
    
    ASPOSE_BARCODE_SHARED_API System::String GetConstructedCodetext() override;
    ASPOSE_BARCODE_SHARED_API void InitFromString(System::String constructedCodetext) override;
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<System::Object> obj) override;
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    
    ASPOSE_BARCODE_SHARED_API MaxiCodeStructuredCodetext();
    
protected:

    System::String _postalCode;
    int32_t _countryCode;
    int32_t _serviceCategory;
    
    virtual void SetPostalCode(System::String value) = 0;
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    static const char16_t GS;
    static const char16_t RS;
    static const char16_t EOT;
    static const System::String StartSequence;
    System::SharedPtr<MaxiCodeSecondMessage> pr_SecondMessage;
    
    System::String GetFirstMessage();
    
};

class ASPOSE_BARCODE_SHARED_CLASS MaxiCodeSecondMessage : public System::Object
{
    typedef MaxiCodeSecondMessage ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    virtual ASPOSE_BARCODE_SHARED_API System::String GetMessage() = 0;
    
};

class ASPOSE_BARCODE_SHARED_CLASS MaxiCodeStandartSecondMessage : public Aspose::BarCode::ComplexBarcode::MaxiCodeSecondMessage
{
    typedef MaxiCodeStandartSecondMessage ThisType;
    typedef Aspose::BarCode::ComplexBarcode::MaxiCodeSecondMessage BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    ASPOSE_BARCODE_SHARED_API System::String get_Message();
    ASPOSE_BARCODE_SHARED_API void set_Message(System::String value);
    
    ASPOSE_BARCODE_SHARED_API System::String GetMessage() override;
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<System::Object> obj) override;
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    
private:

    System::String _message;
    
};

class ASPOSE_BARCODE_SHARED_CLASS MaxiCodeStructuredSecondMessage : public Aspose::BarCode::ComplexBarcode::MaxiCodeSecondMessage
{
    typedef MaxiCodeStructuredSecondMessage ThisType;
    typedef Aspose::BarCode::ComplexBarcode::MaxiCodeSecondMessage BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    ASPOSE_BARCODE_SHARED_API int32_t get_Year() const;
    ASPOSE_BARCODE_SHARED_API void set_Year(int32_t value);
    ASPOSE_BARCODE_SHARED_API System::SharedPtr<System::Collections::Generic::List<System::String>> get_Identifiers() const;
    
    ASPOSE_BARCODE_SHARED_API void Add(System::String identifier);
    ASPOSE_BARCODE_SHARED_API void Clear();
    ASPOSE_BARCODE_SHARED_API System::String GetMessage() override;
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<System::Object> obj) override;
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    
    ASPOSE_BARCODE_SHARED_API MaxiCodeStructuredSecondMessage();
    
protected:

    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    static const char16_t GS;
    static const char16_t RS;
    System::String StartSequence;
    int32_t _year;
    System::SharedPtr<System::Collections::Generic::List<System::String>> _identifiers;
    
};

class ASPOSE_BARCODE_SHARED_CLASS MaxiCodeCodetextMode2 : public Aspose::BarCode::ComplexBarcode::MaxiCodeStructuredCodetext
{
    typedef MaxiCodeCodetextMode2 ThisType;
    typedef Aspose::BarCode::ComplexBarcode::MaxiCodeStructuredCodetext BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::MaxiCodeMode GetMode() const override;
    
    ASPOSE_BARCODE_SHARED_API MaxiCodeCodetextMode2();
    
protected:

    ASPOSE_BARCODE_SHARED_API void SetPostalCode(System::String postalCode) override;
    
};

class ASPOSE_BARCODE_SHARED_CLASS MaxiCodeCodetextMode3 : public Aspose::BarCode::ComplexBarcode::MaxiCodeStructuredCodetext
{
    typedef MaxiCodeCodetextMode3 ThisType;
    typedef Aspose::BarCode::ComplexBarcode::MaxiCodeStructuredCodetext BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::MaxiCodeMode GetMode() const override;
    
    ASPOSE_BARCODE_SHARED_API MaxiCodeCodetextMode3();
    
protected:

    ASPOSE_BARCODE_SHARED_API void SetPostalCode(System::String postalCode) override;
    
};

class ASPOSE_BARCODE_SHARED_CLASS MaxiCodeStandardCodetext : public Aspose::BarCode::ComplexBarcode::MaxiCodeCodetext
{
    typedef MaxiCodeStandardCodetext ThisType;
    typedef Aspose::BarCode::ComplexBarcode::MaxiCodeCodetext BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::MaxiCodeMode get_Mode();
    ASPOSE_BARCODE_SHARED_API void set_Mode(Aspose::BarCode::Generation::MaxiCodeMode value);
    ASPOSE_BARCODE_SHARED_API System::String get_Message() const;
    ASPOSE_BARCODE_SHARED_API void set_Message(System::String value);
    
    ASPOSE_BARCODE_SHARED_API Aspose::BarCode::Generation::MaxiCodeMode GetMode() const override;
    ASPOSE_BARCODE_SHARED_API System::String GetConstructedCodetext() override;
    ASPOSE_BARCODE_SHARED_API void InitFromString(System::String constructedCodetext) override;
    ASPOSE_BARCODE_SHARED_API bool Equals(System::SharedPtr<System::Object> obj) override;
    ASPOSE_BARCODE_SHARED_API int32_t GetHashCode() const override;
    
    ASPOSE_BARCODE_SHARED_API MaxiCodeStandardCodetext();
    
protected:

    void SetMode(Aspose::BarCode::Generation::MaxiCodeMode mode);
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    Aspose::BarCode::Generation::MaxiCodeMode _mode;
    System::String pr_Message;
    
};

} // namespace ComplexBarcode
} // namespace BarCode
} // namespace Aspose


