#pragma once
// Copyright (c) 2001-2021 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <cstdint>

#include "Encoders/QREncoder/ExtCodetextBuilder.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace Generation
{
enum class DataMatrixEncodeMode;
enum class ECIEncodings;
class ExtCodetextBuilder;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose

namespace Aspose {

namespace BarCode {

namespace Generation {

class ASPOSE_BARCODE_SHARED_CLASS DataMatrixExtCodetextBuilder : public Aspose::BarCode::Generation::ExtCodetextBuilder
{
    typedef DataMatrixExtCodetextBuilder ThisType;
    typedef Aspose::BarCode::Generation::ExtCodetextBuilder BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
protected:

    class ExtCodetextWithEncodeMode : public Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem
    {
        typedef ExtCodetextWithEncodeMode ThisType;
        typedef Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem BaseType;
        
        typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
        RTTI_INFO_DECL();
        
    public:
    
        System::String Codetext;
        DataMatrixEncodeMode EncodeMode;
        
        ExtCodetextWithEncodeMode(System::String aCodetext, DataMatrixEncodeMode aEncodeMode);
        
    protected:
    
        #ifdef ASPOSE_GET_SHARED_MEMBERS
        void GetSharedMembers(System::Object::shared_members_type& result) const override;
        #endif
        
        
    };
    
    class ExtECICodetextWithEncodeMode : public Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem
    {
        typedef ExtECICodetextWithEncodeMode ThisType;
        typedef Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem BaseType;
        
        typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
        RTTI_INFO_DECL();
        
    public:
    
        ECIEncodings eciEncoding;
        System::String Codetext;
        DataMatrixEncodeMode EncodeMode;
        
        ExtECICodetextWithEncodeMode(ECIEncodings eciEncoding, System::String aCodetext, DataMatrixEncodeMode aEncodeMode);
        
    protected:
    
        #ifdef ASPOSE_GET_SHARED_MEMBERS
        void GetSharedMembers(System::Object::shared_members_type& result) const override;
        #endif
        
        
    };
    
    
public:

    ASPOSE_BARCODE_SHARED_API void AddECICodetextWithEncodeMode(ECIEncodings ECIEncoding, DataMatrixEncodeMode encodeMode, System::String codetext);
    ASPOSE_BARCODE_SHARED_API void AddCodetextWithEncodeMode(DataMatrixEncodeMode encodeMode, System::String codetext);
    ASPOSE_BARCODE_SHARED_API System::String GetExtendedCodetext() override;
    
protected:

    System::String ConvertToStringECICodetext(System::SharedPtr<ExtCodetextBuilder::ExtCodeItem> aItem);
    System::String ConvertToStringCodetextWithEncodeMode(System::SharedPtr<ExtCodetextBuilder::ExtCodeItem> aItem, bool isShield);
    System::String ConvertToStringECICodetextWithEncodeMode(System::SharedPtr<ExtCodetextBuilder::ExtCodeItem> aItem);
    System::String ConvertToStringPlainCodetext(System::SharedPtr<ExtCodetextBuilder::ExtCodeItem> aItem, bool isShield, bool isShieldEncodeMode);
    
private:

    bool IsNeedToShieldItemFromPrevEncodeMode(int32_t Index);
    System::String GetModePrefix(DataMatrixEncodeMode encodeMode);
    
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose


