#pragma once
// Copyright (c) 2001-2021 Aspose Pty Ltd. All Rights Reserved.

#include <cstdint>

#include "Encoders/QREncoder/ExtCodetextBuilder.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace Generation
{
class ExtCodetextBuilder;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose
namespace System
{
class String;
} // namespace System

namespace Aspose {

namespace BarCode {

namespace Generation {

class ASPOSE_BARCODE_SHARED_CLASS DotCodeExtCodetextBuilder : public Aspose::BarCode::Generation::ExtCodetextBuilder
{
    typedef DotCodeExtCodetextBuilder ThisType;
    typedef Aspose::BarCode::Generation::ExtCodetextBuilder BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
protected:

    class FNC1FormatIdentifier : public Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem
    {
        typedef FNC1FormatIdentifier ThisType;
        typedef Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem BaseType;
        
        typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
        RTTI_INFO_DECL();
        
    };
    
    class FNC3ReaderInitialization : public Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem
    {
        typedef FNC3ReaderInitialization ThisType;
        typedef Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem BaseType;
        
        typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
        RTTI_INFO_DECL();
        
    };
    
    class FNC3SymbolSeparator : public Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem
    {
        typedef FNC3SymbolSeparator ThisType;
        typedef Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem BaseType;
        
        typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
        RTTI_INFO_DECL();
        
    };
    
    class StructuredAppendMode : public Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem
    {
        typedef StructuredAppendMode ThisType;
        typedef Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem BaseType;
        
        typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
        RTTI_INFO_DECL();
        
    public:
    
        int32_t get_ID() const;
        void set_ID(int32_t value);
        int32_t get_Count() const;
        void set_Count(int32_t value);
        
        StructuredAppendMode(int32_t id, int32_t count);
        
    private:
    
        int32_t _id;
        int32_t _count;
        
    };
    
    
public:

    ASPOSE_BARCODE_SHARED_API void AddFNC1FormatIdentifier();
    ASPOSE_BARCODE_SHARED_API void AddFNC3SymbolSeparator();
    ASPOSE_BARCODE_SHARED_API void AddFNC3ReaderInitialization();
    ASPOSE_BARCODE_SHARED_API void AddStructuredAppendMode(int32_t barcodeId, int32_t barcodesCount);
    ASPOSE_BARCODE_SHARED_API System::String GetExtendedCodetext() override;
    
protected:

    System::String ConvertToStringFNC1FormatIdentifier(System::SharedPtr<ExtCodetextBuilder::ExtCodeItem> aItem, bool isShield);
    System::String ConvertToStringFNC3ReaderInitialization(System::SharedPtr<ExtCodetextBuilder::ExtCodeItem> aItem, bool isShield);
    System::String ConvertToStringFNC3SymbolSeparator(System::SharedPtr<ExtCodetextBuilder::ExtCodeItem> aItem, bool isShield);
    System::String ConvertToStringStructuredAppendMode(System::SharedPtr<ExtCodetextBuilder::ExtCodeItem> aItem, bool isShield);
    System::String ConvertToStringECICodetext(System::SharedPtr<ExtCodetextBuilder::ExtCodeItem> aItem);
    System::String ConvertToStringPlainCodetext(System::SharedPtr<ExtCodetextBuilder::ExtCodeItem> aItem, bool isShield);
    
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose


