#pragma once

#include <system/string.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose {

namespace BarCode {

namespace Generation {

class ASPOSE_BARCODE_SHARED_CLASS HanXinExtCodetextBuilder : public System::Object
{
    typedef HanXinExtCodetextBuilder ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
public:

    ASPOSE_BARCODE_SHARED_API HanXinExtCodetextBuilder();
    
    ASPOSE_BARCODE_SHARED_API void AddECI(System::String text, int32_t encoding);
    ASPOSE_BARCODE_SHARED_API void AddAuto(System::String text);
    ASPOSE_BARCODE_SHARED_API void AddBinary(System::String text);
    ASPOSE_BARCODE_SHARED_API void AddURI(System::String text);
    ASPOSE_BARCODE_SHARED_API void AddText(System::String text);
    ASPOSE_BARCODE_SHARED_API void AddNumeric(System::String text);
    ASPOSE_BARCODE_SHARED_API void AddUnicode(System::String text);
    ASPOSE_BARCODE_SHARED_API void AddCommonChineseRegionOne(System::String text);
    ASPOSE_BARCODE_SHARED_API void AddCommonChineseRegionTwo(System::String text);
    ASPOSE_BARCODE_SHARED_API void AddGB18030TwoByte(System::String text);
    ASPOSE_BARCODE_SHARED_API void AddGB18030FourByte(System::String text);
    ASPOSE_BARCODE_SHARED_API void AddGS1(System::String text);
    ASPOSE_BARCODE_SHARED_API System::String GetExtendedCodetext();
    
private:

    System::String _codetext;
    bool _eciStarted;
    
    void AddFragment(System::String text, System::String prefix, bool canBeAfterEci);
    
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose


