#pragma once
// Copyright (c) 2001-2021 Aspose Pty Ltd. All Rights Reserved.

#include <system/string.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace Generation
{
class AztecExtCodetextBuilder;
class DataMatrixExtCodetextBuilder;
class DotCodeExtCodetextBuilder;
enum class ECIEncodings;
class MaxiCodeExtCodetextBuilder;
class QrExtCodetextBuilder;
} // namespace Generation
} // namespace BarCode
} // namespace Aspose
namespace System
{
namespace Collections
{
namespace Generic
{
template <typename> class List;
} // namespace Generic
} // namespace Collections
} // namespace System

namespace Aspose {

namespace BarCode {

namespace Generation {

class ASPOSE_BARCODE_SHARED_CLASS ExtCodetextBuilder : public System::Object
{
    typedef ExtCodetextBuilder ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
    friend class Aspose::BarCode::Generation::AztecExtCodetextBuilder;
    friend class Aspose::BarCode::Generation::DataMatrixExtCodetextBuilder;
    friend class Aspose::BarCode::Generation::DotCodeExtCodetextBuilder;
    friend class Aspose::BarCode::Generation::MaxiCodeExtCodetextBuilder;
    friend class Aspose::BarCode::Generation::QrExtCodetextBuilder;
    
protected:

    class ExtCodeItem : public System::Object
    {
        typedef ExtCodeItem ThisType;
        typedef System::Object BaseType;
        
        typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
        RTTI_INFO_DECL();
        
    };
    
    class ExtPlainCodetext : public Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem
    {
        typedef ExtPlainCodetext ThisType;
        typedef Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem BaseType;
        
        typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
        RTTI_INFO_DECL();
        
    public:
    
        System::String Codetext;
        
        ExtPlainCodetext(System::String aCodetext);
        
    };
    
    class ExtECICodetext : public Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem
    {
        typedef ExtECICodetext ThisType;
        typedef Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem BaseType;
        
        typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
        RTTI_INFO_DECL();
        
    public:
    
        ECIEncodings eciEncoding;
        System::String Codetext;
        
        ExtECICodetext(ECIEncodings eciEncoding, System::String aCodetext);
        
    protected:
    
        #ifdef ASPOSE_GET_SHARED_MEMBERS
        void GetSharedMembers(System::Object::shared_members_type& result) const override;
        #endif
        
        
    };
    
    
public:

    virtual ASPOSE_BARCODE_SHARED_API void Clear();
    ASPOSE_BARCODE_SHARED_API void AddPlainCodetext(System::String codetext);
    ASPOSE_BARCODE_SHARED_API void AddECICodetext(ECIEncodings ECIEncoding, System::String codetext);
    virtual ASPOSE_BARCODE_SHARED_API System::String GetExtendedCodetext() = 0;
    
    ASPOSE_BARCODE_SHARED_API ExtCodetextBuilder();
    
protected:

    System::SharedPtr<System::Collections::Generic::List<System::SharedPtr<ExtCodetextBuilder::ExtCodeItem>>> m_List;
    
    bool IsNeedToShieldItemFromPrevECI(int32_t Index);
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose


