#pragma once
// Copyright (c) 2001-2021 Aspose Pty Ltd. All Rights Reserved.

#include "Encoders/QREncoder/ExtCodetextBuilder.h"
#include "aspose_barcode_api_defs.h"

namespace Aspose {

namespace BarCode {

namespace Generation {

class ASPOSE_BARCODE_SHARED_CLASS QrExtCodetextBuilder : public Aspose::BarCode::Generation::ExtCodetextBuilder
{
    typedef QrExtCodetextBuilder ThisType;
    typedef Aspose::BarCode::Generation::ExtCodetextBuilder BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
protected:

    class FNC1FirstPosItem : public Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem
    {
        typedef FNC1FirstPosItem ThisType;
        typedef Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem BaseType;
        
        typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
        RTTI_INFO_DECL();
        
    };
    
    class FNC1SecondPosItem : public Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem
    {
        typedef FNC1SecondPosItem ThisType;
        typedef Aspose::BarCode::Generation::ExtCodetextBuilder::ExtCodeItem BaseType;
        
        typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
        RTTI_INFO_DECL();
        
    public:
    
        System::String Codetext;
        
        FNC1SecondPosItem(System::String aCodetext);
        
    };
    
    
public:

    ASPOSE_BARCODE_SHARED_API void AddFNC1FirstPosition();
    ASPOSE_BARCODE_SHARED_API void AddFNC1SecondPosition(System::String codetext);
    ASPOSE_BARCODE_SHARED_API void AddFNC1GroupSeparator();
    ASPOSE_BARCODE_SHARED_API System::String GetExtendedCodetext() override;
    
protected:

    System::String ConvertToStringFNC1FirstPos(System::SharedPtr<ExtCodetextBuilder::ExtCodeItem> aItem, bool isShield);
    System::String ConvertToStringFNC1SecondPos(System::SharedPtr<ExtCodetextBuilder::ExtCodeItem> aItem, bool isShield);
    System::String ConvertToStringECICodetext(System::SharedPtr<ExtCodetextBuilder::ExtCodeItem> aItem);
    System::String ConvertToStringPlainCodetext(System::SharedPtr<ExtCodetextBuilder::ExtCodeItem> aItem, bool isShield);
    
};

} // namespace Generation
} // namespace BarCode
} // namespace Aspose


