#pragma once
//Copyright(c) 2001-2022 Aspose Pty Ltd.All rights reserved.

#include <system/object_ext.h>
#include <system/enum.h>
#include <cstdint>

#include "aspose_barcode_api_defs.h"

namespace Aspose
{
namespace BarCode
{
namespace Common
{
namespace Generic
{
namespace Types
{
template <typename ...> class Tup;
} // namespace Types
} // namespace Generic
} // namespace Common
enum class DigestAlgorithm;
class SecureInvariantStringsMap;
} // namespace BarCode
} // namespace Aspose
namespace System
{
namespace Collections
{
namespace Generic
{
template <typename> class List;
} // namespace Generic
} // namespace Collections
class DateTime;
namespace IO
{
class Stream;
} // namespace IO
namespace Reflection
{
class Assembly;
} // namespace Reflection
} // namespace System

namespace Aspose {

namespace BarCode {

enum class LicenseState
{
    Evaluation,
    Licensed,
    Unknown
};

enum class LicenseErrors
{
    Hacked,
    LicenseFileNotFound,
    InvalidSerialNumber,
    IncorrectSignature,
    SubscriptionExpired,
    LicenseExpired,
    DateTimeHacked,
    IncorrectProduct,
    LicensedCorrectly,
    LicenseException
};

class ASPOSE_BARCODE_SHARED_CLASS License : public System::Object
{
    typedef License ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    ASPOSE_BARCODE_SHARED_RTTI_INFO_DECL();
    
private:

    class LicenseErrorChecker : public System::Object
    {
        typedef LicenseErrorChecker ThisType;
        typedef System::Object BaseType;
        
        typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
        RTTI_INFO_DECL();
        
    public:
    
        void LicenseCheckAndThrow(System::SharedPtr<Common::Generic::Types::Tup<LicenseErrors, System::DateTime, System::DateTime>> errorCode);
        
    };
    
    
public:

    ASPOSE_BARCODE_SHARED_API License();
    
    ASPOSE_BARCODE_SHARED_API void SetLicense(System::String licenseName);
    ASPOSE_BARCODE_SHARED_API void SetLicense(System::SharedPtr<System::IO::Stream> stream);
    
protected:

    static void ResetLicense();
    #ifdef ASPOSE_GET_SHARED_MEMBERS
    ASPOSE_BARCODE_SHARED_API void GetSharedMembers(System::Object::shared_members_type& result) const override;
    #endif
    
    
private:

    System::SharedPtr<System::Reflection::Assembly> _callerAssembly;
    
};

class LicenseCore : public System::Object
{
    typedef LicenseCore ThisType;
    typedef System::Object BaseType;
    
    typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
    RTTI_INFO_DECL();
    
private:

    class ProductFields : public System::Object
    {
        typedef ProductFields ThisType;
        typedef System::Object BaseType;
        
        typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
        RTTI_INFO_DECL();
        
    public:
    
        static const System::String c_PlatformNet;
        static const System::String c_PlatformJava;
        static const System::String c_PlatformCpp;
        static const System::String c_PlatformReportingServices;
        static const System::String c_PlatformPython;
        static const System::String c_PlatformJavaScript;
        System::String productFamily;
        System::SharedPtr<System::Collections::Generic::List<System::String>> platforms;
        System::SharedPtr<System::Collections::Generic::List<System::String>> functions;
        
        ProductFields();
        
    protected:
    
        #ifdef ASPOSE_GET_SHARED_MEMBERS
        void GetSharedMembers(System::Object::shared_members_type& result) const override;
        #endif
        
        
    };
    
    class LicenseXMLFields : public System::Object
    {
        typedef LicenseXMLFields ThisType;
        typedef System::Object BaseType;
        
        typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
        RTTI_INFO_DECL();
        
    public:
    
        System::String licenseData;
        System::String licenseSignature;
        System::String serialNumber;
        System::SharedPtr<System::Collections::Generic::List<System::String>> products;
        System::String subscriptionExpiry;
        System::String licenseExpiry;
        
        LicenseXMLFields();
        
    protected:
    
        #ifdef ASPOSE_GET_SHARED_MEMBERS
        void GetSharedMembers(System::Object::shared_members_type& result) const override;
        #endif
        
        
    };
    
    class LicenseBlackListFields : public System::Object
    {
        typedef LicenseBlackListFields ThisType;
        typedef System::Object BaseType;
        
        typedef ::System::BaseTypesInfo<BaseType> ThisTypeBaseTypesInfo;
        RTTI_INFO_DECL();
        
    public:
    
        System::String licenseData;
        System::String licenseSignature;
        System::SharedPtr<System::Collections::Generic::List<System::String>> numbers;
        
        LicenseBlackListFields();
        
    protected:
    
        #ifdef ASPOSE_GET_SHARED_MEMBERS
        void GetSharedMembers(System::Object::shared_members_type& result) const override;
        #endif
        
        
    };
    
    
public:

    LicenseCore();
    
    void ResetLicense();
    void SetLicense(System::String licenseName, System::SharedPtr<System::Reflection::Assembly> clientAssembly, System::SharedPtr<Common::Generic::Types::Tup<LicenseErrors, System::DateTime, System::DateTime>> errorCode);
    void SetLicense(System::SharedPtr<System::IO::Stream> stream, System::SharedPtr<Common::Generic::Types::Tup<LicenseErrors, System::DateTime, System::DateTime>> errorCode);
    static void SetMeteredLicense(bool isPlugin, System::String pluginName);
    static void RemoveMeteredLicense();
    System::SharedPtr<System::Object> EncodeSignature(System::SharedPtr<System::Object> inputObj);
    static System::String GetFileNameInFolderOfAssembly(System::String fileName, System::SharedPtr<System::Reflection::Assembly> assembly);
    
private:

    static const int32_t c_MaxLoadedFileStreamSize;
    static System::SharedPtr<SecureInvariantStringsMap> gAsposeBlackListCache;
    static System::SharedPtr<SecureInvariantStringsMap> gConholdateBlackListCache;
    
    void SetLicenseInternal(System::SharedPtr<System::IO::Stream> stream, System::SharedPtr<Common::Generic::Types::Tup<LicenseErrors, System::DateTime, System::DateTime>> errorCode);
    System::SharedPtr<SecureInvariantStringsMap> LoadBlackList(System::String blackListResourceName, System::String keyModulus);
    System::SharedPtr<System::Object> GetCurrentDateTimeFromFileStructure(bool isUTC);
    System::String FindKeyModulusString(System::String signatureString, System::SharedPtr<System::Collections::Generic::List<System::String>> products);
    bool VerifySignature(System::String dataString, System::String signatureString, System::String keyModulusString);
    int32_t VerifySignature(System::SharedPtr<System::Object> inputObj);
    System::SharedPtr<System::Object> GetHashAlgorithmPrefix(System::SharedPtr<System::Object> keyModulusObj);
    DigestAlgorithm GetHashAlgorithmType(System::SharedPtr<System::Object> keyModulusObj);
    System::SharedPtr<System::Object> ReadLicenseDataSignature(System::SharedPtr<System::IO::Stream> input);
    System::SharedPtr<System::Object> ReadLicenseXML(System::SharedPtr<System::IO::Stream> input);
    System::SharedPtr<System::Object> ReadLicenseBlackList(System::SharedPtr<System::IO::Stream> input);
    System::SharedPtr<System::IO::Stream> GetResourceStreamByPartialName(System::String resourcename, System::SharedPtr<System::Reflection::Assembly> assembly);
    System::SharedPtr<System::IO::Stream> GetLoadedFileStream(System::String fileName);
    System::SharedPtr<System::IO::Stream> FindAndLoadLicenseByName(System::String licenseName, System::SharedPtr<System::Reflection::Assembly> clientAssembly);
    
};

} // namespace BarCode
} // namespace Aspose

template<>
struct EnumMetaInfo<Aspose::BarCode::LicenseState>
{
    static const ASPOSE_BARCODE_SHARED_API std::array<std::pair<Aspose::BarCode::LicenseState, const char_t*>, 3>& values();
};
template<>
struct EnumMetaInfo<Aspose::BarCode::LicenseErrors>
{
    static const ASPOSE_BARCODE_SHARED_API std::array<std::pair<Aspose::BarCode::LicenseErrors, const char_t*>, 10>& values();
};



